import React, { Component } from 'react';
import VisibilityIcon from '@material-ui/icons/VisibilitySharp';
import VisibilityOffIcon from '@material-ui/icons/VisibilityOffSharp';
import MiradorMenuButton from '../containers/MiradorMenuButton';
/**
 * AnnotationSettings is a component to handle various annotation
 * display settings in the Annotation companion window
*/

export class AnnotationSettings extends Component {
  /**
   * Returns the rendered component
  */
  render() {
    const _this$props = this.props,
          displayAll = _this$props.displayAll,
          displayAllDisabled = _this$props.displayAllDisabled,
          t = _this$props.t,
          toggleAnnotationDisplay = _this$props.toggleAnnotationDisplay;
    return /*#__PURE__*/React.createElement(MiradorMenuButton, {
      "aria-label": t(displayAll ? 'displayNoAnnotations' : 'highlightAllAnnotations'),
      onClick: toggleAnnotationDisplay,
      disabled: displayAllDisabled,
      size: "small"
    }, displayAll ? /*#__PURE__*/React.createElement(VisibilityIcon, null) : /*#__PURE__*/React.createElement(VisibilityOffIcon, null));
  }

}