import React, { Component } from 'react';
import Accordion from '@material-ui/core/Accordion';
import AccordionSummary from '@material-ui/core/AccordionSummary';
import AccordionDetails from '@material-ui/core/AccordionDetails';
import Typography from '@material-ui/core/Typography';
import Alert from '@material-ui/lab/Alert';
import ExpandMoreIcon from '@material-ui/icons/ExpandMore';
import { PluginHook } from './PluginHook';
/** */

export class ErrorContent extends Component {
  /** */
  render() {
    const _this$props = this.props,
          classes = _this$props.classes,
          error = _this$props.error,
          metadata = _this$props.metadata,
          showJsError = _this$props.showJsError,
          t = _this$props.t;
    if (!showJsError) return null;
    return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Alert, {
      elevation: 6,
      variant: "filled",
      severity: "error"
    }, t('errorDialogTitle')), showJsError && /*#__PURE__*/React.createElement(Accordion, {
      square: true,
      className: classes.alert
    }, /*#__PURE__*/React.createElement(AccordionSummary, {
      expandIcon: /*#__PURE__*/React.createElement(ExpandMoreIcon, null)
    }, /*#__PURE__*/React.createElement(Typography, null, t('jsError', {
      message: error.message,
      name: error.name
    }))), /*#__PURE__*/React.createElement(AccordionDetails, {
      className: classes.details
    }, /*#__PURE__*/React.createElement("pre", null, t('jsStack', {
      stack: error.stack
    })), metadata && /*#__PURE__*/React.createElement("pre", null, JSON.stringify(metadata, null, 2)))), /*#__PURE__*/React.createElement(PluginHook, this.props));
  }

}
ErrorContent.defaultProps = {
  metadata: null,
  showJsError: true,
  t: key => key
};