import _isUndefined from "lodash/isUndefined";
import React, { Component } from 'react';
import Dialog from '@material-ui/core/Dialog';
import DialogContent from '@material-ui/core/DialogContent';
import DialogTitle from '@material-ui/core/DialogTitle';
import { DialogActions, DialogContentText, Typography } from '@material-ui/core';
import Button from '@material-ui/core/Button';

/**
 */
export class ErrorDialog extends Component {
  /**
   * render
   * @return
   */
  render() {
    const _this$props = this.props,
          error = _this$props.error,
          removeError = _this$props.removeError,
          t = _this$props.t;
    const hasError = !_isUndefined(error);
    return error ? /*#__PURE__*/React.createElement(Dialog, {
      "aria-labelledby": "error-dialog-title",
      id: "error-dialog",
      onClose: () => removeError(error.id),
      open: hasError
    }, /*#__PURE__*/React.createElement(DialogTitle, {
      id: "error-dialog-title",
      disableTypography: true
    }, /*#__PURE__*/React.createElement(Typography, {
      variant: "h2"
    }, t('errorDialogTitle'))), /*#__PURE__*/React.createElement(DialogContent, {
      disableTypography: true
    }, /*#__PURE__*/React.createElement(DialogContentText, {
      variant: "body2",
      noWrap: true,
      color: "inherit"
    }, `${error.message}`), /*#__PURE__*/React.createElement(DialogActions, null, /*#__PURE__*/React.createElement(Button, {
      onClick: () => removeError(error.id),
      variant: "contained"
    }, t('errorDialogConfirm'))))) : null;
  }

}
ErrorDialog.defaultProps = {
  error: null,
  removeError: () => {},
  t: key => key
};