import React, { Component } from 'react';
import Paper from '@material-ui/core/Paper';
import GalleryViewThumbnail from '../containers/GalleryViewThumbnail';
/**
 * Renders a GalleryView overview of the manifest.
 */

export class GalleryView extends Component {
  /**
   * Renders things
   */
  render() {
    const _this$props = this.props,
          canvases = _this$props.canvases,
          classes = _this$props.classes,
          viewingDirection = _this$props.viewingDirection,
          windowId = _this$props.windowId;
    const htmlDir = viewingDirection === 'right-to-left' ? 'rtl' : 'ltr';
    return /*#__PURE__*/React.createElement(Paper, {
      component: "section",
      dir: htmlDir,
      square: true,
      elevation: 0,
      className: classes.galleryContainer,
      id: `${windowId}-gallery`
    }, canvases.map(canvas => /*#__PURE__*/React.createElement(GalleryViewThumbnail, {
      key: canvas.id,
      windowId: windowId,
      canvas: canvas
    })));
  }

}
GalleryView.defaultProps = {
  classes: {},
  viewingDirection: ''
};