import React, { Component } from 'react';
import MenuItem from '@material-ui/core/MenuItem';
import FormControl from '@material-ui/core/FormControl';
import Select from '@material-ui/core/Select';
import Typography from '@material-ui/core/Typography';
/**
 * Provide a locale picker
 */

export class LocalePicker extends Component {
  /**
   * render
   * @return
   */
  render() {
    const _this$props = this.props,
          availableLocales = _this$props.availableLocales,
          classes = _this$props.classes,
          locale = _this$props.locale,
          setLocale = _this$props.setLocale;
    if (!setLocale || availableLocales.length < 2) return /*#__PURE__*/React.createElement(React.Fragment, null);
    return /*#__PURE__*/React.createElement(FormControl, null, /*#__PURE__*/React.createElement(Select, {
      MenuProps: {
        anchorOrigin: {
          horizontal: 'left',
          vertical: 'bottom'
        },
        getContentAnchorEl: null
      },
      displayEmpty: true,
      value: locale,
      onChange: e => {
        setLocale(e.target.value);
      },
      name: "locale",
      classes: {
        select: classes.select
      },
      className: classes.selectEmpty
    }, availableLocales.map(l => /*#__PURE__*/React.createElement(MenuItem, {
      key: l,
      value: l
    }, /*#__PURE__*/React.createElement(Typography, {
      variant: "body2"
    }, l)))));
  }

}
LocalePicker.defaultProps = {
  availableLocales: [],
  classes: {},
  locale: '',
  setLocale: undefined
};