import React, { Component } from 'react';
import Typography from '@material-ui/core/Typography';
import Link from '@material-ui/core/Link';
import classNames from 'classnames';
import CollapsibleSection from '../containers/CollapsibleSection';
import ns from '../config/css-ns';
import { PluginHook } from './PluginHook';
/**
 * ManifestRelatedLinks
 */

export class ManifestRelatedLinks extends Component {
  /**
   * render
   * @return
   */
  render() {
    const _this$props = this.props,
          classes = _this$props.classes,
          homepage = _this$props.homepage,
          manifestUrl = _this$props.manifestUrl,
          renderings = _this$props.renderings,
          seeAlso = _this$props.seeAlso,
          id = _this$props.id,
          t = _this$props.t;
    return /*#__PURE__*/React.createElement(CollapsibleSection, {
      id: `${id}-related`,
      label: t('related')
    }, /*#__PURE__*/React.createElement(Typography, {
      "aria-labelledby": `${id}-related ${id}-related-heading`,
      id: `${id}-related-heading`,
      variant: "h4",
      component: "h5"
    }, t('links')), /*#__PURE__*/React.createElement("dl", {
      className: classNames(ns('label-value-metadata'), classes.labelValueMetadata)
    }, homepage && /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Typography, {
      variant: "subtitle2",
      component: "dt"
    }, t('iiif_homepage')), homepage.map(page => /*#__PURE__*/React.createElement(Typography, {
      key: page.value,
      variant: "body1",
      component: "dd"
    }, /*#__PURE__*/React.createElement(Link, {
      target: "_blank",
      rel: "noopener noreferrer",
      href: page.value
    }, page.label || page.value)))), renderings && renderings.length > 0 && /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Typography, {
      variant: "subtitle2",
      component: "dt"
    }, t('iiif_renderings')), renderings.map(rendering => /*#__PURE__*/React.createElement(Typography, {
      key: rendering.value,
      variant: "body1",
      component: "dd"
    }, /*#__PURE__*/React.createElement(Link, {
      target: "_blank",
      rel: "noopener noreferrer",
      href: rendering.value
    }, rendering.label || rendering.value)))), seeAlso && /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Typography, {
      variant: "subtitle2",
      component: "dt"
    }, t('iiif_seeAlso')), seeAlso.map(related => /*#__PURE__*/React.createElement(Typography, {
      key: related.value,
      variant: "body1",
      component: "dd"
    }, /*#__PURE__*/React.createElement(Link, {
      target: "_blank",
      rel: "noopener noreferrer",
      href: related.value
    }, related.label || related.value), related.format && /*#__PURE__*/React.createElement(Typography, {
      component: "span"
    }, `(${related.format})`)))), manifestUrl && /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Typography, {
      variant: "subtitle2",
      component: "dt"
    }, t('iiif_manifest')), /*#__PURE__*/React.createElement(Typography, {
      variant: "body1",
      component: "dd"
    }, /*#__PURE__*/React.createElement(Link, {
      target: "_blank",
      rel: "noopener noreferrer",
      href: manifestUrl
    }, manifestUrl)))), /*#__PURE__*/React.createElement(PluginHook, this.props));
  }

}
ManifestRelatedLinks.defaultProps = {
  homepage: null,
  manifestUrl: null,
  renderings: null,
  seeAlso: null,
  t: key => key
};