import { Component } from 'react';

/**
 * Opens a new window for click
 */
export class NewWindow extends Component {
  /** */
  constructor(props) {
    super(props);
    this.released = undefined;
    this.window = null;
    this.checkIfWindowClosed = null;
  }
  /** */


  componentDidMount() {
    this.openWindow();
  }
  /**
   * Close the opened window we unmount
   */


  componentWillUnmount() {
    if (this.window) {
      this.window.close();
    }
  }
  /** @private */


  onClose() {
    const _this$props = this.props,
          onClose = _this$props.onClose,
          url = _this$props.url;
    if (this.released) return;
    this.released = true;
    clearInterval(this.checkIfWindowClosed);
    onClose(url);
  }
  /** */


  openWindow() {
    const _this$props2 = this.props,
          depWindow = _this$props2.depWindow,
          features = _this$props2.features,
          name = _this$props2.name,
          url = _this$props2.url;
    this.window = (depWindow || window).open(url, name, features);
    this.released = false;
    this.checkIfWindowClosed = setInterval(() => {
      if (!this.window || this.window.closed) {
        this.onClose();
      }
    }, 250);
  }
  /** */


  render() {
    return null;
  }

}
NewWindow.defaultProps = {
  depWindow: undefined,
  features: undefined,
  name: undefined
};