import React, { Component } from 'react';
import Button from '@material-ui/core/Button';
import Chip from '@material-ui/core/Chip';
import Typography from '@material-ui/core/Typography';
import CompanionWindow from '../containers/CompanionWindow';
import SearchPanelControls from '../containers/SearchPanelControls';
import SearchResults from '../containers/SearchResults';
/** */

export class SearchPanel extends Component {
  /** */
  constructor(props) {
    super(props);
    this.containerRef = /*#__PURE__*/React.createRef();
  }
  /** */


  render() {
    const _this$props = this.props,
          classes = _this$props.classes,
          fetchSearch = _this$props.fetchSearch,
          windowId = _this$props.windowId,
          id = _this$props.id,
          query = _this$props.query,
          removeSearch = _this$props.removeSearch,
          searchService = _this$props.searchService,
          suggestedSearches = _this$props.suggestedSearches,
          t = _this$props.t;
    return /*#__PURE__*/React.createElement(CompanionWindow, {
      ariaLabel: t('searchTitle'),
      title: /*#__PURE__*/React.createElement(React.Fragment, null, t('searchTitle'), query && query !== '' && /*#__PURE__*/React.createElement(Chip, {
        className: classes.clearChip,
        color: "secondary",
        label: t('clearSearch'),
        onClick: removeSearch,
        onDelete: removeSearch,
        size: "small",
        variant: "outlined"
      })),
      windowId: windowId,
      id: id,
      titleControls: /*#__PURE__*/React.createElement(SearchPanelControls, {
        companionWindowId: id,
        windowId: windowId
      }),
      ref: this.containerRef
    }, /*#__PURE__*/React.createElement(SearchResults, {
      containerRef: this.containerRef,
      companionWindowId: id,
      windowId: windowId
    }), fetchSearch && suggestedSearches && query === '' && suggestedSearches.map(search => /*#__PURE__*/React.createElement(Typography, {
      component: "p",
      key: search,
      variant: "body1"
    }, /*#__PURE__*/React.createElement(Button, {
      className: classes.inlineButton,
      color: "secondary",
      onClick: () => fetchSearch(`${searchService.id}?q=${search}`, search)
    }, t('suggestSearch', {
      query: search
    })))));
  }

}
SearchPanel.defaultProps = {
  classes: {},
  fetchSearch: undefined,
  query: '',
  suggestedSearches: [],
  t: key => key
};