import React, { Component } from 'react';
import MenuList from '@material-ui/core/MenuList';
import MenuItem from '@material-ui/core/MenuItem';
import { ScrollTo } from './ScrollTo';
import MiradorCanvas from '../lib/MiradorCanvas';
import SidebarIndexItem from '../containers/SidebarIndexItem';
import SidebarIndexThumbnail from '../containers/SidebarIndexThumbnail';
/** */

export class SidebarIndexList extends Component {
  /** @private */
  getIdAndLabelOfCanvases() {
    const canvases = this.props.canvases;
    return canvases.map((canvas, index) => ({
      id: canvas.id,
      label: new MiradorCanvas(canvas).getLabel()
    }));
  }
  /** */


  render() {
    const _this$props = this.props,
          canvases = _this$props.canvases,
          classes = _this$props.classes,
          containerRef = _this$props.containerRef,
          selectedCanvasIds = _this$props.selectedCanvasIds,
          setCanvas = _this$props.setCanvas,
          variant = _this$props.variant,
          windowId = _this$props.windowId;
    const canvasesIdAndLabel = this.getIdAndLabelOfCanvases(canvases);
    let Item;

    switch (variant) {
      case 'thumbnail':
        Item = SidebarIndexThumbnail;
        break;

      default:
        Item = SidebarIndexItem;
    }

    return /*#__PURE__*/React.createElement(MenuList, {
      variant: "selectedMenu"
    }, canvasesIdAndLabel.map((canvas, canvasIndex) => {
      const onClick = () => {
        setCanvas(windowId, canvas.id);
      }; // eslint-disable-line require-jsdoc, max-len


      return /*#__PURE__*/React.createElement(ScrollTo, {
        containerRef: containerRef,
        key: `${canvas.id}-${variant}`,
        offsetTop: 96 // offset for the height of the form above
        ,
        scrollTo: selectedCanvasIds.includes(canvas.id)
      }, /*#__PURE__*/React.createElement(MenuItem, {
        key: canvas.id,
        className: classes.listItem,
        alignItems: "flex-start",
        onClick: onClick,
        button: true,
        component: "li",
        selected: selectedCanvasIds.includes(canvas.id)
      }, /*#__PURE__*/React.createElement(Item, {
        label: canvas.label,
        canvas: canvases[canvasIndex]
      })));
    }));
  }

}
SidebarIndexList.defaultProps = {
  selectedCanvasIds: [],
  variant: 'item'
};