function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React, { Component } from 'react';
import Button from '@material-ui/core/Button';
import Paper from '@material-ui/core/Paper';
import Collapse from '@material-ui/core/Collapse';
import DialogActions from '@material-ui/core/DialogActions';
import Typography from '@material-ui/core/Typography';
import LockIcon from '@material-ui/icons/LockSharp';
import SanitizedHtml from '../containers/SanitizedHtml';
import { PluginHook } from './PluginHook';
/** */

export class WindowAuthenticationBar extends Component {
  /** */
  constructor(props) {
    super(props);
    this.state = {
      open: false
    };
    this.setOpen = this.setOpen.bind(this);
    this.onSubmit = this.onSubmit.bind(this);
  }
  /** */


  onSubmit() {
    const onConfirm = this.props.onConfirm;
    this.setOpen(false);
    onConfirm();
  }
  /** Toggle the full description */


  setOpen(open) {
    this.setState(state => _objectSpread(_objectSpread({}, state), {}, {
      open
    }));
  }
  /** */


  render() {
    const _this$props = this.props,
          classes = _this$props.classes,
          confirmButton = _this$props.confirmButton,
          continueLabel = _this$props.continueLabel,
          header = _this$props.header,
          description = _this$props.description,
          icon = _this$props.icon,
          label = _this$props.label,
          t = _this$props.t,
          ruleSet = _this$props.ruleSet,
          hasLogoutService = _this$props.hasLogoutService,
          status = _this$props.status,
          ConfirmProps = _this$props.ConfirmProps;
    if (status === 'ok' && !hasLogoutService) return null;
    const open = this.state.open;
    const button = /*#__PURE__*/React.createElement(Button, Object.assign({
      onClick: this.onSubmit,
      className: classes.buttonInvert,
      color: "secondary"
    }, ConfirmProps), confirmButton || t('login'));

    if (!description && !header) {
      return /*#__PURE__*/React.createElement(Paper, {
        square: true,
        elevation: 4,
        color: "secondary",
        classes: {
          root: classes.paper
        }
      }, /*#__PURE__*/React.createElement("div", {
        className: classes.topBar
      }, icon || /*#__PURE__*/React.createElement(LockIcon, {
        className: classes.icon
      }), /*#__PURE__*/React.createElement(Typography, {
        className: classes.label,
        component: "h3",
        variant: "body1",
        color: "inherit"
      }, ruleSet ? /*#__PURE__*/React.createElement(SanitizedHtml, {
        htmlString: label,
        ruleSet: ruleSet
      }) : label), /*#__PURE__*/React.createElement(PluginHook, this.props), button));
    }

    return /*#__PURE__*/React.createElement(Paper, {
      square: true,
      elevation: 4,
      color: "secondary",
      classes: {
        root: classes.paper
      }
    }, /*#__PURE__*/React.createElement(Button, {
      fullWidth: true,
      className: classes.topBar,
      onClick: () => this.setOpen(true),
      component: "div",
      color: "inherit"
    }, icon || /*#__PURE__*/React.createElement(LockIcon, {
      className: classes.icon
    }), /*#__PURE__*/React.createElement(Typography, {
      className: classes.label,
      component: "h3",
      variant: "body1",
      color: "inherit"
    }, ruleSet ? /*#__PURE__*/React.createElement(SanitizedHtml, {
      htmlString: label,
      ruleSet: ruleSet
    }) : label), /*#__PURE__*/React.createElement(PluginHook, this.props), /*#__PURE__*/React.createElement("span", {
      className: classes.fauxButton
    }, !open && /*#__PURE__*/React.createElement(Typography, {
      variant: "button",
      color: "inherit"
    }, continueLabel || t('continue')))), /*#__PURE__*/React.createElement(Collapse, {
      in: open,
      onClose: () => this.setOpen(false)
    }, /*#__PURE__*/React.createElement(Typography, {
      variant: "body1",
      color: "inherit",
      className: classes.expanded
    }, ruleSet ? /*#__PURE__*/React.createElement(SanitizedHtml, {
      htmlString: header,
      ruleSet: ruleSet
    }) : header, header && description ? ': ' : '', ruleSet ? /*#__PURE__*/React.createElement(SanitizedHtml, {
      htmlString: description,
      ruleSet: ruleSet
    }) : description), /*#__PURE__*/React.createElement(DialogActions, null, /*#__PURE__*/React.createElement(Button, {
      onClick: () => this.setOpen(false),
      color: "inherit"
    }, t('cancel')), button)));
  }

}
WindowAuthenticationBar.defaultProps = {
  confirmButton: undefined,
  ConfirmProps: {},
  continueLabel: undefined,
  description: undefined,
  hasLogoutService: true,
  header: undefined,
  icon: undefined,
  ruleSet: 'iiif',
  status: undefined,
  t: k => k
};