import React, { Component } from 'react';
import Typography from '@material-ui/core/Typography';
import AnnotationSettings from '../containers/AnnotationSettings';
import CanvasAnnotations from '../containers/CanvasAnnotations';
import CompanionWindow from '../containers/CompanionWindow';
import ns from '../config/css-ns';
/**
 * WindowSideBarAnnotationsPanel ~
*/

export class WindowSideBarAnnotationsPanel extends Component {
  /**
   * Returns the rendered component
  */
  render() {
    const _this$props = this.props,
          annotationCount = _this$props.annotationCount,
          classes = _this$props.classes,
          canvasIds = _this$props.canvasIds,
          t = _this$props.t,
          windowId = _this$props.windowId,
          id = _this$props.id;
    return /*#__PURE__*/React.createElement(CompanionWindow, {
      title: t('annotations'),
      paperClassName: ns('window-sidebar-annotation-panel'),
      windowId: windowId,
      id: id,
      titleControls: /*#__PURE__*/React.createElement(AnnotationSettings, {
        windowId: windowId
      })
    }, /*#__PURE__*/React.createElement("div", {
      className: classes.section
    }, /*#__PURE__*/React.createElement(Typography, {
      component: "p",
      variant: "subtitle2"
    }, t('showingNumAnnotations', {
      number: annotationCount
    }))), canvasIds.map((canvasId, index) => /*#__PURE__*/React.createElement(CanvasAnnotations, {
      canvasId: canvasId,
      key: canvasId,
      index: index,
      totalSize: canvasIds.length,
      windowId: windowId
    })));
  }

}
WindowSideBarAnnotationsPanel.defaultProps = {
  canvasIds: [],
  t: key => key
};