import React, { Component } from 'react';
import CompanionWindow from '../containers/CompanionWindow';
import CanvasInfo from '../containers/CanvasInfo';
import LocalePicker from '../containers/LocalePicker';
import ManifestInfo from '../containers/ManifestInfo';
import CollectionInfo from '../containers/CollectionInfo';
import ManifestRelatedLinks from '../containers/ManifestRelatedLinks';
import ns from '../config/css-ns';
/**
 * WindowSideBarInfoPanel
 */

export class WindowSideBarInfoPanel extends Component {
  /**
   * render
   * @return
   */
  render() {
    const _this$props = this.props,
          windowId = _this$props.windowId,
          id = _this$props.id,
          canvasIds = _this$props.canvasIds,
          classes = _this$props.classes,
          collectionPath = _this$props.collectionPath,
          t = _this$props.t,
          locale = _this$props.locale,
          setLocale = _this$props.setLocale,
          availableLocales = _this$props.availableLocales,
          showLocalePicker = _this$props.showLocalePicker;
    return /*#__PURE__*/React.createElement(CompanionWindow, {
      title: t('aboutThisItem'),
      paperClassName: ns('window-sidebar-info-panel'),
      windowId: windowId,
      id: id,
      titleControls: showLocalePicker && /*#__PURE__*/React.createElement(LocalePicker, {
        locale: locale,
        setLocale: setLocale,
        availableLocales: availableLocales
      })
    }, canvasIds.map((canvasId, index) => /*#__PURE__*/React.createElement("div", {
      key: canvasId,
      className: classes.section
    }, /*#__PURE__*/React.createElement(CanvasInfo, {
      id: id,
      canvasId: canvasId,
      index: index,
      totalSize: canvasIds.length,
      windowId: windowId
    }))), collectionPath.length > 0 && /*#__PURE__*/React.createElement("div", {
      className: classes.section
    }, /*#__PURE__*/React.createElement(CollectionInfo, {
      id: id,
      windowId: windowId
    })), /*#__PURE__*/React.createElement("div", {
      className: classes.section
    }, /*#__PURE__*/React.createElement(ManifestInfo, {
      id: id,
      windowId: windowId
    })), /*#__PURE__*/React.createElement("div", {
      className: classes.section
    }, /*#__PURE__*/React.createElement(ManifestRelatedLinks, {
      id: id,
      windowId: windowId
    })));
  }

}
WindowSideBarInfoPanel.defaultProps = {
  availableLocales: [],
  canvasIds: [],
  classes: {},
  collectionPath: [],
  locale: '',
  setLocale: undefined,
  showLocalePicker: false,
  t: key => key
};