import React, { Component } from 'react';
import FormControlLabel from '@material-ui/core/FormControlLabel';
import ListSubheader from '@material-ui/core/ListSubheader';
import MenuItem from '@material-ui/core/MenuItem';
import ThumbnailsOffIcon from '@material-ui/icons/CropDinSharp';
import ThumbnailNavigationBottomIcon from './icons/ThumbnailNavigationBottomIcon';
import ThumbnailNavigationRightIcon from './icons/ThumbnailNavigationRightIcon';
/**
 *
 */

export class WindowThumbnailSettings extends Component {
  /**
   * constructor -
   */
  constructor(props) {
    super(props);
    this.handleChange = this.handleChange.bind(this);
  }
  /**
   * @private
   */


  handleChange(value) {
    const _this$props = this.props,
          windowId = _this$props.windowId,
          setWindowThumbnailPosition = _this$props.setWindowThumbnailPosition;
    setWindowThumbnailPosition(windowId, value);
  }
  /**
   * render
   *
   * @return {type}  description
   */


  render() {
    const _this$props2 = this.props,
          classes = _this$props2.classes,
          handleClose = _this$props2.handleClose,
          t = _this$props2.t,
          thumbnailNavigationPosition = _this$props2.thumbnailNavigationPosition,
          direction = _this$props2.direction;
    return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(ListSubheader, {
      role: "presentation",
      disableSticky: true,
      tabIndex: "-1"
    }, t('thumbnails')), /*#__PURE__*/React.createElement(MenuItem, {
      className: classes.MenuItem,
      onClick: () => {
        this.handleChange('off');
        handleClose();
      }
    }, /*#__PURE__*/React.createElement(FormControlLabel, {
      value: "off",
      classes: {
        label: thumbnailNavigationPosition === 'off' ? classes.selectedLabel : classes.label
      },
      control: /*#__PURE__*/React.createElement(ThumbnailsOffIcon, {
        color: thumbnailNavigationPosition === 'off' ? 'secondary' : undefined
      }),
      label: t('off'),
      labelPlacement: "bottom"
    })), /*#__PURE__*/React.createElement(MenuItem, {
      className: classes.MenuItem,
      onClick: () => {
        this.handleChange('far-bottom');
        handleClose();
      }
    }, /*#__PURE__*/React.createElement(FormControlLabel, {
      value: "far-bottom",
      classes: {
        label: thumbnailNavigationPosition === 'far-bottom' ? classes.selectedLabel : classes.label
      },
      control: /*#__PURE__*/React.createElement(ThumbnailNavigationBottomIcon, {
        color: thumbnailNavigationPosition === 'far-bottom' ? 'secondary' : undefined
      }),
      label: t('bottom'),
      labelPlacement: "bottom"
    })), /*#__PURE__*/React.createElement(MenuItem, {
      className: classes.MenuItem,
      onClick: () => {
        this.handleChange('far-right');
        handleClose();
      }
    }, /*#__PURE__*/React.createElement(FormControlLabel, {
      value: "far-right",
      classes: {
        label: thumbnailNavigationPosition === 'far-right' ? classes.selectedLabel : classes.label
      },
      control: /*#__PURE__*/React.createElement(ThumbnailNavigationRightIcon, {
        color: thumbnailNavigationPosition === 'far-right' ? 'secondary' : undefined,
        style: direction === 'rtl' ? {
          transform: 'rotate(180deg)'
        } : {}
      }),
      label: t('right'),
      labelPlacement: "bottom"
    })));
  }

}
WindowThumbnailSettings.defaultProps = {
  handleClose: () => {},
  t: key => key
};