import React, { Component } from 'react';
import MoreVertIcon from '@material-ui/icons/MoreVertSharp';
import Menu from '@material-ui/core/Menu';
import MiradorMenuButton from '../containers/MiradorMenuButton';
import { PluginHook } from './PluginHook';
import ns from '../config/css-ns';
/**
 *
 */

export class WindowTopBarPluginMenu extends Component {
  /**
   * constructor -
   */
  constructor(props) {
    super(props);
    this.state = {
      anchorEl: null
    };
    this.handleMenuClick = this.handleMenuClick.bind(this);
    this.handleMenuClose = this.handleMenuClose.bind(this);
  }
  /**
   * Set the anchorEl state to the click target
   */


  handleMenuClick(event) {
    this.setState({
      anchorEl: event.currentTarget
    });
  }
  /**
   * Set the anchorEl state to null (closing the menu)
   */


  handleMenuClose() {
    this.setState({
      anchorEl: null
    });
  }
  /**
   * render component
   */


  render() {
    const _this$props = this.props,
          classes = _this$props.classes,
          containerId = _this$props.containerId,
          PluginComponents = _this$props.PluginComponents,
          t = _this$props.t,
          windowId = _this$props.windowId,
          menuIcon = _this$props.menuIcon;
    const anchorEl = this.state.anchorEl;
    if (!PluginComponents || PluginComponents.length === 0) return /*#__PURE__*/React.createElement(React.Fragment, null);
    return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(MiradorMenuButton, {
      "aria-haspopup": "true",
      "aria-label": t('windowPluginMenu'),
      "aria-owns": anchorEl ? `window-plugin-menu_${windowId}` : undefined,
      className: anchorEl ? classes.ctrlBtnSelected : null,
      onClick: this.handleMenuClick
    }, menuIcon), /*#__PURE__*/React.createElement(Menu, {
      id: `window-plugin-menu_${windowId}`,
      container: document.querySelector(`#${containerId} .${ns('viewer')}`),
      anchorEl: anchorEl,
      anchorOrigin: {
        horizontal: 'right',
        vertical: 'bottom'
      },
      transformOrigin: {
        horizontal: 'right',
        vertical: 'top'
      },
      getContentAnchorEl: null,
      open: Boolean(anchorEl),
      onClose: () => this.handleMenuClose()
    }, /*#__PURE__*/React.createElement(PluginHook, Object.assign({
      handleClose: () => this.handleMenuClose()
    }, this.props))));
  }

}
WindowTopBarPluginMenu.defaultProps = {
  classes: {},
  menuIcon: /*#__PURE__*/React.createElement(MoreVertIcon, null),
  PluginComponents: []
};