import React, { Component } from 'react';
import Menu from '@material-ui/core//Menu';
import ListSubheader from '@material-ui/core/ListSubheader';
import WindowThumbnailSettings from '../containers/WindowThumbnailSettings';
import WindowViewSettings from '../containers/WindowViewSettings';
import { PluginHook } from './PluginHook';
import ns from '../config/css-ns';
/** Renders plugins */

function PluginHookWithHeader(props) {
  const PluginComponents = props.PluginComponents,
        t = props.t; // eslint-disable-line react/prop-types

  return PluginComponents ? /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(ListSubheader, {
    role: "presentation",
    disableSticky: true,
    tabIndex: "-1"
  }, t('windowPluginButtons')), /*#__PURE__*/React.createElement(PluginHook, props)) : null;
}
/**
 */


export class WindowTopMenu extends Component {
  /**
   * render
   * @return
   */
  render() {
    const _this$props = this.props,
          containerId = _this$props.containerId,
          handleClose = _this$props.handleClose,
          anchorEl = _this$props.anchorEl,
          showThumbnailNavigationSettings = _this$props.showThumbnailNavigationSettings,
          toggleDraggingEnabled = _this$props.toggleDraggingEnabled,
          windowId = _this$props.windowId;
    return /*#__PURE__*/React.createElement(Menu, {
      id: `window-menu_${windowId}`,
      container: document.querySelector(`#${containerId} .${ns('viewer')}`),
      anchorEl: anchorEl,
      anchorOrigin: {
        horizontal: 'right',
        vertical: 'bottom'
      },
      transformOrigin: {
        horizontal: 'right',
        vertical: 'top'
      },
      getContentAnchorEl: null,
      open: Boolean(anchorEl),
      onClose: handleClose,
      onEntering: toggleDraggingEnabled,
      onExit: toggleDraggingEnabled,
      orientation: "horizontal"
    }, /*#__PURE__*/React.createElement(WindowViewSettings, {
      windowId: windowId,
      handleClose: handleClose
    }), showThumbnailNavigationSettings && /*#__PURE__*/React.createElement(WindowThumbnailSettings, {
      windowId: windowId,
      handleClose: handleClose
    }), /*#__PURE__*/React.createElement(PluginHookWithHeader, this.props));
  }

}
WindowTopMenu.defaultProps = {
  anchorEl: null,
  showThumbnailNavigationSettings: true
};