import React, { Component } from 'react';
import FormControlLabel from '@material-ui/core/FormControlLabel';
import MenuItem from '@material-ui/core/MenuItem';
import ListSubheader from '@material-ui/core/ListSubheader';
import SingleIcon from '@material-ui/icons/CropOriginalSharp';
import ScrollViewIcon from '@material-ui/icons/ViewColumn';
import BookViewIcon from './icons/BookViewIcon';
import GalleryViewIcon from './icons/GalleryViewIcon';
/**
 *
 */

export class WindowViewSettings extends Component {
  /**
   * constructor -
   */
  constructor(props) {
    super(props);
    this.handleChange = this.handleChange.bind(this);
  }
  /**
   * @private
   */


  handleChange(value) {
    const _this$props = this.props,
          windowId = _this$props.windowId,
          setWindowViewType = _this$props.setWindowViewType;
    setWindowViewType(windowId, value);
  }
  /**
   * render
   *
   * @return {type}  description
   */


  render() {
    const _this$props2 = this.props,
          classes = _this$props2.classes,
          handleClose = _this$props2.handleClose,
          t = _this$props2.t,
          windowViewType = _this$props2.windowViewType,
          viewTypes = _this$props2.viewTypes;
    const iconMap = {
      book: BookViewIcon,
      gallery: GalleryViewIcon,
      scroll: ScrollViewIcon,
      single: SingleIcon
    };
    /** Suspiciously similar to a component, yet if it is invoked through JSX
        none of the click handlers work? */

    const menuItem = ({
      value,
      Icon
    }) => /*#__PURE__*/React.createElement(MenuItem, {
      key: value,
      className: classes.MenuItem,
      autoFocus: windowViewType === value,
      onClick: () => {
        this.handleChange(value);
        handleClose();
      }
    }, /*#__PURE__*/React.createElement(FormControlLabel, {
      value: value,
      classes: {
        label: windowViewType === value ? classes.selectedLabel : classes.label
      },
      control: /*#__PURE__*/React.createElement(Icon, {
        color: windowViewType === value ? 'secondary' : undefined
      }),
      label: t(value),
      labelPlacement: "bottom"
    }));

    if (viewTypes.length === 0) return null;
    return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(ListSubheader, {
      role: "presentation",
      disableSticky: true,
      tabIndex: "-1"
    }, t('view')), viewTypes.map(value => menuItem({
      Icon: iconMap[value],
      value
    })));
  }

}
WindowViewSettings.defaultProps = {
  handleClose: () => {},
  t: key => key,
  viewTypes: []
};