import React, { Component, lazy, Suspense } from 'react';
import WindowCanvasNavigationControls from '../containers/WindowCanvasNavigationControls';
const OSDViewer = /*#__PURE__*/lazy(() => import('../containers/OpenSeadragonViewer'));
/**
 * Represents a WindowViewer in the mirador workspace. Responsible for mounting
 * OSD and Navigation
 */

export class WindowViewer extends Component {
  /** */
  constructor(props) {
    super(props);
    this.state = {};
  }
  /** */


  static getDerivedStateFromError(error) {
    // Update state so the next render will show the fallback UI.
    return {
      hasError: true
    };
  }
  /**
   * Renders things
   */


  render() {
    const windowId = this.props.windowId;
    const hasError = this.state.hasError;

    if (hasError) {
      return /*#__PURE__*/React.createElement(React.Fragment, null);
    }

    return /*#__PURE__*/React.createElement(Suspense, {
      fallback: /*#__PURE__*/React.createElement("div", null)
    }, /*#__PURE__*/React.createElement(OSDViewer, {
      windowId: windowId
    }, /*#__PURE__*/React.createElement(WindowCanvasNavigationControls, {
      windowId: windowId
    })));
  }

}