import React, { Component } from 'react';
import Fab from '@material-ui/core/Fab';
import Tooltip from '@material-ui/core/Tooltip';
import AddIcon from '@material-ui/icons/AddSharp';
import CloseIcon from '@material-ui/icons/CloseSharp';
/**
 */

export class WorkspaceAddButton extends Component {
  /**
   * render
   * @return
   */
  render() {
    const _this$props = this.props,
          classes = _this$props.classes,
          t = _this$props.t,
          setWorkspaceAddVisibility = _this$props.setWorkspaceAddVisibility,
          isWorkspaceAddVisible = _this$props.isWorkspaceAddVisible,
          useExtendedFab = _this$props.useExtendedFab;
    return /*#__PURE__*/React.createElement(Tooltip, {
      title: isWorkspaceAddVisible ? t('closeAddResourceMenu') : t('addResource')
    }, /*#__PURE__*/React.createElement(Fab, {
      size: "medium",
      color: "primary",
      id: "addBtn",
      disableRipple: true,
      "aria-label": isWorkspaceAddVisible ? t('closeAddResourceMenu') : useExtendedFab && t('startHere') || t('addResource'),
      className: classes.fab,
      classes: {
        primary: classes.fabPrimary,
        secondary: classes.fabSecondary
      },
      variant: useExtendedFab ? 'extended' : 'round',
      onClick: () => {
        setWorkspaceAddVisibility(!isWorkspaceAddVisible);
      }
    }, isWorkspaceAddVisible ? /*#__PURE__*/React.createElement(CloseIcon, null) : /*#__PURE__*/React.createElement(AddIcon, null), useExtendedFab && t('startHere')));
  }

}
WorkspaceAddButton.defaultProps = {
  isWorkspaceAddVisible: false,
  t: key => key
};