import React, { Component } from 'react';
import classNames from 'classnames';
import ErrorDialog from '../containers/ErrorDialog';
import WorkspaceControlPanel from '../containers/WorkspaceControlPanel';
import Workspace from '../containers/Workspace';
import WorkspaceAdd from '../containers/WorkspaceAdd';
import BackgroundPluginArea from '../containers/BackgroundPluginArea';
import ns from '../config/css-ns';
/**
 * This is the top level Mirador component.
 * @prop {Object} manifests
 */

export class WorkspaceArea extends Component {
  /**
   * render
   * @return {String} - HTML markup for the component
   */
  render() {
    const _this$props = this.props,
          classes = _this$props.classes,
          controlPanelVariant = _this$props.controlPanelVariant,
          isWorkspaceAddVisible = _this$props.isWorkspaceAddVisible,
          isWorkspaceControlPanelVisible = _this$props.isWorkspaceControlPanelVisible,
          lang = _this$props.lang,
          t = _this$props.t;
    return /*#__PURE__*/React.createElement(React.Fragment, null, isWorkspaceControlPanelVisible && /*#__PURE__*/React.createElement(WorkspaceControlPanel, {
      variant: controlPanelVariant
    }), /*#__PURE__*/React.createElement("main", {
      className: classNames(classes.viewer, ns('viewer')),
      lang: lang,
      "aria-label": t('workspace')
    }, isWorkspaceAddVisible ? /*#__PURE__*/React.createElement(WorkspaceAdd, null) : /*#__PURE__*/React.createElement(Workspace, null), /*#__PURE__*/React.createElement(ErrorDialog, null), /*#__PURE__*/React.createElement(BackgroundPluginArea, null)));
  }

}
WorkspaceArea.defaultProps = {
  controlPanelVariant: undefined,
  isWorkspaceAddVisible: false,
  lang: undefined
};