import React, { Component } from 'react';
import Button from '@material-ui/core/Button';
import Dialog from '@material-ui/core/Dialog';
import DialogActions from '@material-ui/core/DialogActions';
import DialogTitle from '@material-ui/core/DialogTitle';
import Typography from '@material-ui/core/Typography';
import Snackbar from '@material-ui/core/Snackbar';
import IconButton from '@material-ui/core/IconButton';
import CloseIcon from '@material-ui/icons/Close';
import { CopyToClipboard } from 'react-copy-to-clipboard';
import ScrollIndicatedDialogContent from '../containers/ScrollIndicatedDialogContent';
/**
 */

export class WorkspaceExport extends Component {
  /** */
  constructor(props) {
    super(props);
    this.state = {
      copied: false
    };
    this.onCopy = this.onCopy.bind(this);
    this.handleClose = this.handleClose.bind(this);
  }
  /** Handle closing after the content is copied and the snackbar is done */


  handleClose() {
    const handleClose = this.props.handleClose;
    handleClose();
  }
  /** Show the snackbar */


  onCopy() {
    this.setState({
      copied: true
    });
  }
  /**
   * @private
   */


  exportedState() {
    const exportableState = this.props.exportableState;
    return JSON.stringify(exportableState, null, 2);
  }
  /**
   * render
   * @return
   */


  render() {
    const _this$props = this.props,
          children = _this$props.children,
          container = _this$props.container,
          open = _this$props.open,
          t = _this$props.t;
    const copied = this.state.copied;

    if (copied) {
      return /*#__PURE__*/React.createElement(Snackbar, {
        anchorOrigin: {
          horizontal: 'center',
          vertical: 'top'
        },
        open: true,
        autoHideDuration: 6000,
        onClose: this.handleClose,
        message: t('exportCopied'),
        action: /*#__PURE__*/React.createElement(IconButton, {
          size: "small",
          "aria-label": t('dismiss'),
          color: "inherit",
          onClick: this.handleClose
        }, /*#__PURE__*/React.createElement(CloseIcon, {
          fontSize: "small"
        }))
      });
    }

    return /*#__PURE__*/React.createElement(Dialog, {
      id: "workspace-settings",
      container: container,
      open: open,
      onClose: this.handleClose,
      scroll: "paper",
      fullWidth: true,
      maxWidth: "sm"
    }, /*#__PURE__*/React.createElement(DialogTitle, {
      id: "form-dialog-title",
      disableTypography: true
    }, /*#__PURE__*/React.createElement(Typography, {
      variant: "h2"
    }, t('downloadExport'))), /*#__PURE__*/React.createElement(ScrollIndicatedDialogContent, null, children, /*#__PURE__*/React.createElement("pre", null, this.exportedState())), /*#__PURE__*/React.createElement(DialogActions, null, /*#__PURE__*/React.createElement(Button, {
      onClick: this.handleClose
    }, t('cancel')), /*#__PURE__*/React.createElement(CopyToClipboard, {
      onCopy: this.onCopy,
      text: this.exportedState()
    }, /*#__PURE__*/React.createElement(Button, {
      variant: "contained",
      color: "primary"
    }, t('copy')))));
  }

}
WorkspaceExport.defaultProps = {
  children: null,
  container: null,
  open: false,
  t: key => key
};