import React, { Component } from 'react';
import Dialog from '@material-ui/core/Dialog';
import DialogTitle from '@material-ui/core/DialogTitle';
import { DialogActions, TextField, Typography } from '@material-ui/core';
import Button from '@material-ui/core/Button';
import ScrollIndicatedDialogContent from '../containers/ScrollIndicatedDialogContent';
/**
 */

export class WorkspaceImport extends Component {
  /**
   *
   * constructor
   */
  constructor(props) {
    super(props);
    this.state = {
      configImportValue: ''
    };
    this.handleImportConfig = this.handleImportConfig.bind(this);
    this.handleChange = this.handleChange.bind(this);
  }
  /**
   * @private
   */


  handleChange(event) {
    event.preventDefault();
    this.setState({
      configImportValue: event.target.value
    });
  }
  /**
   * @private
   */


  handleImportConfig(event) {
    const _this$props = this.props,
          handleClose = _this$props.handleClose,
          importConfig = _this$props.importConfig;
    const configImportValue = this.state.configImportValue;

    try {
      const configJSON = JSON.parse(configImportValue);
      importConfig(configJSON);
      handleClose();
    } catch (ex) {
      const addError = this.props.addError;
      addError(ex.toString());
    }
  }
  /**
   * render
   * @return
   */


  render() {
    const _this$props2 = this.props,
          classes = _this$props2.classes,
          handleClose = _this$props2.handleClose,
          open = _this$props2.open,
          t = _this$props2.t;
    return /*#__PURE__*/React.createElement(Dialog, {
      "aria-labelledby": "workspace-import-title",
      id: "workspace-import",
      onEscapeKeyDown: handleClose,
      onClose: handleClose,
      open: open,
      fullWidth: true,
      maxWidth: "sm"
    }, /*#__PURE__*/React.createElement(DialogTitle, {
      id: "workspace-import-title",
      disableTypography: true
    }, /*#__PURE__*/React.createElement(Typography, {
      variant: "h2"
    }, t('importWorkspace'))), /*#__PURE__*/React.createElement(ScrollIndicatedDialogContent, null, /*#__PURE__*/React.createElement(TextField, {
      className: classes.textField,
      id: "workspace-import-input",
      multiline: true,
      onChange: this.handleChange,
      rows: "15",
      variant: "filled",
      inputProps: {
        autoFocus: 'autofocus',
        className: classes.textInput
      },
      helperText: t('importWorkspaceHint')
    })), /*#__PURE__*/React.createElement(DialogActions, null, /*#__PURE__*/React.createElement(Button, {
      className: classes.cancelBtn,
      onClick: handleClose
    }, t('cancel')), /*#__PURE__*/React.createElement(Button, {
      color: "primary",
      onClick: this.handleImportConfig,
      variant: "contained"
    }, t('import'))));
  }

}
WorkspaceImport.defaultProps = {
  classes: {},
  open: false,
  t: key => key
};