import React, { Component } from 'react';
import classNames from 'classnames';
import MoreHorizontalIcon from '@material-ui/icons/MoreHorizSharp';
import MiradorMenuButton from '../containers/MiradorMenuButton';
import WorkspaceOptionsMenu from '../containers/WorkspaceOptionsMenu';
/**
 * WorkspaceOptionsButton ~
*/

export class WorkspaceOptionsButton extends Component {
  /**
   * constructor -
   */
  constructor(props) {
    super(props);
    this.state = {
      anchorEl: null
    };
    this.handleMenuClick = this.handleMenuClick.bind(this);
    this.handleMenuClose = this.handleMenuClose.bind(this);
  }
  /**
   * @private
   */


  handleMenuClick(event) {
    this.setState({
      anchorEl: event.currentTarget
    });
  }
  /**
   * @private
   */


  handleMenuClose() {
    this.setState({
      anchorEl: null
    });
  }
  /**
   * Returns the rendered component
  */


  render() {
    const _this$props = this.props,
          classes = _this$props.classes,
          t = _this$props.t;
    const anchorEl = this.state.anchorEl;
    return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(MiradorMenuButton, {
      "aria-label": t('workspaceOptions'),
      className: classNames(classes.ctrlBtn, anchorEl ? classes.ctrlBtnSelected : null),
      onClick: this.handleMenuClick
    }, /*#__PURE__*/React.createElement(MoreHorizontalIcon, null)), /*#__PURE__*/React.createElement(WorkspaceOptionsMenu, {
      anchorEl: anchorEl,
      handleClose: this.handleMenuClose
    }));
  }

}