import React, { Component } from 'react';
import AddCircleIcon from '@material-ui/icons/AddCircleOutlineSharp';
import RemoveCircleIcon from '@material-ui/icons/RemoveCircleOutlineSharp';
import RestoreZoomIcon from './icons/RestoreZoomIcon';
import MiradorMenuButton from '../containers/MiradorMenuButton';
/**
 */

export class ZoomControls extends Component {
  /**
   * constructor -
   */
  constructor(props) {
    super(props);
    this.handleZoomInClick = this.handleZoomInClick.bind(this);
    this.handleZoomOutClick = this.handleZoomOutClick.bind(this);
  }
  /**
   * @private
   */


  handleZoomInClick() {
    const _this$props = this.props,
          windowId = _this$props.windowId,
          updateViewport = _this$props.updateViewport,
          viewer = _this$props.viewer;
    updateViewport(windowId, {
      zoom: viewer.zoom * 2
    });
  }
  /**
   * @private
   */


  handleZoomOutClick() {
    const _this$props2 = this.props,
          windowId = _this$props2.windowId,
          updateViewport = _this$props2.updateViewport,
          viewer = _this$props2.viewer;
    updateViewport(windowId, {
      zoom: viewer.zoom / 2
    });
  }
  /**
   * render
   * @return
   */


  render() {
    const _this$props3 = this.props,
          displayDivider = _this$props3.displayDivider,
          showZoomControls = _this$props3.showZoomControls,
          classes = _this$props3.classes,
          t = _this$props3.t,
          zoomToWorld = _this$props3.zoomToWorld;

    if (!showZoomControls) {
      return /*#__PURE__*/React.createElement(React.Fragment, null);
    }

    return /*#__PURE__*/React.createElement("div", {
      className: classes.zoom_controls
    }, /*#__PURE__*/React.createElement(MiradorMenuButton, {
      "aria-label": t('zoomIn'),
      onClick: this.handleZoomInClick
    }, /*#__PURE__*/React.createElement(AddCircleIcon, null)), /*#__PURE__*/React.createElement(MiradorMenuButton, {
      "aria-label": t('zoomOut'),
      onClick: this.handleZoomOutClick
    }, /*#__PURE__*/React.createElement(RemoveCircleIcon, null)), /*#__PURE__*/React.createElement(MiradorMenuButton, {
      "aria-label": t('zoomReset'),
      onClick: () => zoomToWorld(false)
    }, /*#__PURE__*/React.createElement(RestoreZoomIcon, null)), displayDivider && /*#__PURE__*/React.createElement("span", {
      className: classes.divider
    }));
  }

}
ZoomControls.defaultProps = {
  displayDivider: true,
  showZoomControls: false,
  t: key => key,
  updateViewport: () => {},
  viewer: {},
  windowId: ''
};