function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import ActionTypes from '../actions/action-types';
/**
 * catalogReducer
 */

export const catalogReducer = (state = [], action) => {
  switch (action.type) {
    case ActionTypes.ADD_RESOURCE:
      if (state.some(m => m.manifestId === action.manifestId)) return state;
      return [_objectSpread({
        manifestId: action.manifestId
      }, action.payload), ...state];

    case ActionTypes.ADD_WINDOW:
      if (state.some(m => m.manifestId === action.window.manifestId)) return state;
      return [{
        manifestId: action.window.manifestId
      }, ...state];

    case ActionTypes.UPDATE_WINDOW:
      if (!action.payload.manifestId) return state;
      if (state.some(m => m.manifestId === action.payload.manifestId)) return state;
      return [{
        manifestId: action.payload.manifestId
      }, ...state];

    case ActionTypes.REMOVE_RESOURCE:
      return state.filter(r => r.manifestId !== action.manifestId);

    case ActionTypes.IMPORT_CONFIG:
      return action.config.catalog || [];

    case ActionTypes.IMPORT_MIRADOR_STATE:
      return action.state.catalog || [];

    default:
      return state;
  }
};