function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import without from 'lodash/without';
import ActionTypes from '../actions/action-types';
const defaultState = {
  items: []
};
/**
 * errorsReducer
 */

export const errorsReducer = (state = defaultState, action) => {
  let ret;

  switch (action.type) {
    case ActionTypes.ADD_ERROR:
      return _objectSpread(_objectSpread({}, state), {}, {
        [action.id]: {
          id: action.id,
          message: action.message
        },
        items: [...state.items, action.id]
      });
    // eslint-disable-line max-len

    case ActionTypes.RECEIVE_INFO_RESPONSE_FAILURE:
      return _objectSpread(_objectSpread({}, state), {}, {
        [action.infoId]: {
          id: action.infoId,
          message: action.error
        },
        items: [...state.items, action.infoId]
      });

    case ActionTypes.RECEIVE_SEARCH_FAILURE:
      return _objectSpread(_objectSpread({}, state), {}, {
        [action.searchId]: {
          id: action.searchId,
          message: action.error
        },
        items: [...state.items, action.searchId]
      });

    case ActionTypes.REMOVE_ERROR:
      ret = Object.keys(state).reduce((object, key) => {
        if (key !== action.id) {
          object[key] = state[key]; // eslint-disable-line no-param-reassign
        }

        return object;
      }, {});
      ret.items = without(ret.items, action.id);
      return ret;

    case ActionTypes.IMPORT_MIRADOR_STATE:
      return defaultState;

    default:
      return state;
  }
};