function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import _regeneratorRuntime from "@babel/runtime/regenerator";

var _marked = /*#__PURE__*/_regeneratorRuntime.mark(fetchIiifResource),
    _marked2 = /*#__PURE__*/_regeneratorRuntime.mark(fetchIiifResourceWithAuth),
    _marked3 = /*#__PURE__*/_regeneratorRuntime.mark(fetchManifest),
    _marked4 = /*#__PURE__*/_regeneratorRuntime.mark(getAccessTokenService),
    _marked5 = /*#__PURE__*/_regeneratorRuntime.mark(fetchInfoResponse),
    _marked6 = /*#__PURE__*/_regeneratorRuntime.mark(fetchSearchResponse),
    _marked7 = /*#__PURE__*/_regeneratorRuntime.mark(fetchAnnotation),
    _marked8 = /*#__PURE__*/_regeneratorRuntime.mark(fetchResourceManifest),
    _marked9 = /*#__PURE__*/_regeneratorRuntime.mark(fetchManifests),
    _marked10 = /*#__PURE__*/_regeneratorRuntime.mark(iiifSaga);

import { all, call, put, select, takeEvery } from 'redux-saga/effects';
import fetch from 'isomorphic-unfetch';
import { Utils } from 'manifesto.js/dist-esmodule/Utils';
import normalizeUrl from 'normalize-url';
import ActionTypes from '../actions/action-types';
import { receiveManifest, receiveManifestFailure, receiveInfoResponse, receiveInfoResponseFailure, receiveDegradedInfoResponse, receiveSearch, receiveSearchFailure, receiveAnnotation, receiveAnnotationFailure } from '../actions';
import { getManifests, getRequestsConfig, getAccessTokens, selectInfoResponse } from '../selectors';
/** */

function fetchWrapper(url, options, {
  success,
  degraded,
  failure
}) {
  return fetch(url, options).then(response => response.json().then(json => {
    if (response.status === 401) return (degraded || success)({
      json,
      response
    });
    if (response.ok) return success({
      json,
      response
    });
    return failure({
      error: response.statusText,
      json,
      response
    });
  }).catch(error => failure({
    error,
    response
  }))).catch(error => failure({
    error
  }));
}
/** */


function fetchIiifResource(url, options, {
  success,
  degraded,
  failure
}) {
  var _yield$select, _yield$select$preproc, preprocessors, _yield$select$postpro, postprocessors, reqOptions, action;

  return _regeneratorRuntime.wrap(function fetchIiifResource$(_context) {
    while (1) switch (_context.prev = _context.next) {
      case 0:
        _context.next = 2;
        return select(getRequestsConfig);

      case 2:
        _yield$select = _context.sent;
        _yield$select$preproc = _yield$select.preprocessors;
        preprocessors = _yield$select$preproc === void 0 ? [] : _yield$select$preproc;
        _yield$select$postpro = _yield$select.postprocessors;
        postprocessors = _yield$select$postpro === void 0 ? [] : _yield$select$postpro;
        _context.prev = 7;
        reqOptions = preprocessors.reduce((acc, f) => f(url, acc) || acc, options);
        _context.next = 11;
        return call(fetchWrapper, url, reqOptions, {
          degraded,
          failure,
          success
        });

      case 11:
        action = _context.sent;
        action = postprocessors.reduce((acc, f) => f(url, acc) || acc, action);
        return _context.abrupt("return", action);

      case 16:
        _context.prev = 16;
        _context.t0 = _context["catch"](7);
        return _context.abrupt("return", failure({
          error: _context.t0
        }));

      case 19:
      case "end":
        return _context.stop();
    }
  }, _marked, null, [[7, 16]]);
}
/** */


function fetchIiifResourceWithAuth(url, iiifResource, options, {
  degraded,
  failure,
  success
}) {
  var urlOptions, tokenServiceId, tokenService, _yield$call, error, json, response, id, authoritativeTokenService;

  return _regeneratorRuntime.wrap(function fetchIiifResourceWithAuth$(_context2) {
    while (1) switch (_context2.prev = _context2.next) {
      case 0:
        urlOptions = _objectSpread({}, options);

        if (!iiifResource) {
          _context2.next = 7;
          break;
        }

        _context2.next = 4;
        return call(getAccessTokenService, iiifResource);

      case 4:
        tokenService = _context2.sent;
        tokenServiceId = tokenService && tokenService.id;

        if (tokenService && tokenService.json) {
          urlOptions.headers = _objectSpread({
            Authorization: `Bearer ${tokenService.json.accessToken}`
          }, options.headers);
        }

      case 7:
        _context2.next = 9;
        return call(fetchIiifResource, url, urlOptions, {
          failure: arg => arg,
          success: arg => arg
        });

      case 9:
        _yield$call = _context2.sent;
        error = _yield$call.error;
        json = _yield$call.json;
        response = _yield$call.response;

        if (!error) {
          _context2.next = 17;
          break;
        }

        _context2.next = 16;
        return put(failure({
          error,
          json,
          response,
          tokenServiceId
        }));

      case 16:
        return _context2.abrupt("return");

      case 17:
        id = json['@id'] || json.id;

        if (!response.ok) {
          _context2.next = 25;
          break;
        }

        if (!(normalizeUrl(id, {
          stripAuthentication: false
        }) === normalizeUrl(url.replace(/info\.json$/, ''), {
          stripAuthentication: false
        }))) {
          _context2.next = 23;
          break;
        }

        _context2.next = 22;
        return put(success({
          json,
          response,
          tokenServiceId
        }));

      case 22:
        return _context2.abrupt("return");

      case 23:
        _context2.next = 29;
        break;

      case 25:
        if (!(response.status !== 401)) {
          _context2.next = 29;
          break;
        }

        _context2.next = 28;
        return put(failure({
          error,
          json,
          response,
          tokenServiceId
        }));

      case 28:
        return _context2.abrupt("return");

      case 29:
        _context2.next = 31;
        return call(getAccessTokenService, json);

      case 31:
        authoritativeTokenService = _context2.sent;

        if (!(authoritativeTokenService && authoritativeTokenService.id !== tokenServiceId)) {
          _context2.next = 36;
          break;
        }

        _context2.next = 35;
        return call(fetchIiifResourceWithAuth, url, json, options, {
          degraded,
          failure,
          success
        });

      case 35:
        return _context2.abrupt("return");

      case 36:
        _context2.next = 38;
        return put((degraded || success)({
          json,
          response,
          tokenServiceId
        }));

      case 38:
      case "end":
        return _context2.stop();
    }
  }, _marked2);
}
/** */


export function fetchManifest({
  manifestId
}) {
  var callbacks, dispatch;
  return _regeneratorRuntime.wrap(function fetchManifest$(_context3) {
    while (1) switch (_context3.prev = _context3.next) {
      case 0:
        callbacks = {
          failure: ({
            error,
            json,
            response
          }) => receiveManifestFailure(manifestId, typeof error === 'object' ? String(error) : error),
          success: ({
            json,
            response
          }) => receiveManifest(manifestId, json)
        };
        _context3.next = 3;
        return call(fetchIiifResource, manifestId, {}, callbacks);

      case 3:
        dispatch = _context3.sent;
        _context3.next = 6;
        return put(dispatch);

      case 6:
      case "end":
        return _context3.stop();
    }
  }, _marked3);
}
/** @private */

function getAccessTokenService(resource) {
  var manifestoCompatibleResource, services, accessTokens, i, authService, accessTokenService, token;
  return _regeneratorRuntime.wrap(function getAccessTokenService$(_context4) {
    while (1) switch (_context4.prev = _context4.next) {
      case 0:
        manifestoCompatibleResource = resource && resource.__jsonld ? resource : _objectSpread(_objectSpread({}, resource), {}, {
          options: {}
        });
        services = Utils.getServices(manifestoCompatibleResource).filter(s => s.getProfile().match(/http:\/\/iiif.io\/api\/auth\//));

        if (!(services.length === 0)) {
          _context4.next = 4;
          break;
        }

        return _context4.abrupt("return", undefined);

      case 4:
        _context4.next = 6;
        return select(getAccessTokens);

      case 6:
        accessTokens = _context4.sent;

        if (accessTokens) {
          _context4.next = 9;
          break;
        }

        return _context4.abrupt("return", undefined);

      case 9:
        i = 0;

      case 10:
        if (!(i < services.length)) {
          _context4.next = 19;
          break;
        }

        authService = services[i];
        accessTokenService = Utils.getService(authService, 'http://iiif.io/api/auth/1/token') || Utils.getService(authService, 'http://iiif.io/api/auth/0/token');
        token = accessTokenService && accessTokens[accessTokenService.id];

        if (!(token && token.json)) {
          _context4.next = 16;
          break;
        }

        return _context4.abrupt("return", token);

      case 16:
        i += 1;
        _context4.next = 10;
        break;

      case 19:
        return _context4.abrupt("return", undefined);

      case 20:
      case "end":
        return _context4.stop();
    }
  }, _marked4);
}
/** @private */


export function fetchInfoResponse({
  imageResource,
  infoId,
  windowId
}) {
  var iiifResource, callbacks;
  return _regeneratorRuntime.wrap(function fetchInfoResponse$(_context5) {
    while (1) switch (_context5.prev = _context5.next) {
      case 0:
        iiifResource = imageResource;

        if (iiifResource) {
          _context5.next = 5;
          break;
        }

        _context5.next = 4;
        return select(selectInfoResponse, {
          infoId
        });

      case 4:
        iiifResource = _context5.sent;

      case 5:
        callbacks = {
          degraded: ({
            json,
            response,
            tokenServiceId
          }) => receiveDegradedInfoResponse(infoId, json, response.ok, tokenServiceId, windowId),
          failure: ({
            error,
            json,
            response,
            tokenServiceId
          }) => receiveInfoResponseFailure(infoId, error, tokenServiceId),
          success: ({
            json,
            response,
            tokenServiceId
          }) => receiveInfoResponse(infoId, json, response.ok, tokenServiceId)
        };
        _context5.next = 8;
        return call(fetchIiifResourceWithAuth, `${infoId.replace(/\/$/, '')}/info.json`, iiifResource, {}, callbacks);

      case 8:
      case "end":
        return _context5.stop();
    }
  }, _marked5);
}
/** @private */

export function fetchSearchResponse({
  windowId,
  companionWindowId,
  query,
  searchId
}) {
  var callbacks, dispatch;
  return _regeneratorRuntime.wrap(function fetchSearchResponse$(_context6) {
    while (1) switch (_context6.prev = _context6.next) {
      case 0:
        callbacks = {
          failure: ({
            error,
            json,
            response
          }) => receiveSearchFailure(windowId, companionWindowId, searchId, error),
          success: ({
            json,
            response
          }) => receiveSearch(windowId, companionWindowId, searchId, json)
        };
        _context6.next = 3;
        return call(fetchIiifResource, searchId, {}, callbacks);

      case 3:
        dispatch = _context6.sent;
        _context6.next = 6;
        return put(dispatch);

      case 6:
      case "end":
        return _context6.stop();
    }
  }, _marked6);
}
/** @private */

export function fetchAnnotation({
  targetId,
  annotationId
}) {
  var callbacks, dispatch;
  return _regeneratorRuntime.wrap(function fetchAnnotation$(_context7) {
    while (1) switch (_context7.prev = _context7.next) {
      case 0:
        callbacks = {
          failure: ({
            error,
            json,
            response
          }) => receiveAnnotationFailure(targetId, annotationId, error),
          success: ({
            json,
            response
          }) => receiveAnnotation(targetId, annotationId, json)
        };
        _context7.next = 3;
        return call(fetchIiifResource, annotationId, {}, callbacks);

      case 3:
        dispatch = _context7.sent;
        _context7.next = 6;
        return put(dispatch);

      case 6:
      case "end":
        return _context7.stop();
    }
  }, _marked7);
}
/** */

export function fetchResourceManifest({
  manifestId,
  manifestJson
}) {
  var manifests;
  return _regeneratorRuntime.wrap(function fetchResourceManifest$(_context8) {
    while (1) switch (_context8.prev = _context8.next) {
      case 0:
        if (!manifestJson) {
          _context8.next = 4;
          break;
        }

        _context8.next = 3;
        return put(receiveManifest(manifestId, manifestJson));

      case 3:
        return _context8.abrupt("return");

      case 4:
        if (manifestId) {
          _context8.next = 6;
          break;
        }

        return _context8.abrupt("return");

      case 6:
        _context8.next = 8;
        return select(getManifests) || {};

      case 8:
        manifests = _context8.sent;

        if (manifests[manifestId]) {
          _context8.next = 11;
          break;
        }

        return _context8.delegateYield(fetchManifest({
          manifestId
        }), "t0", 11);

      case 11:
      case "end":
        return _context8.stop();
    }
  }, _marked8);
}
/** */

export function fetchManifests(...manifestIds) {
  var manifests, i, manifestId;
  return _regeneratorRuntime.wrap(function fetchManifests$(_context9) {
    while (1) switch (_context9.prev = _context9.next) {
      case 0:
        _context9.next = 2;
        return select(getManifests);

      case 2:
        manifests = _context9.sent;
        i = 0;

      case 4:
        if (!(i < manifestIds.length)) {
          _context9.next = 12;
          break;
        }

        manifestId = manifestIds[i];

        if (manifests[manifestId]) {
          _context9.next = 9;
          break;
        }

        _context9.next = 9;
        return call(fetchManifest, {
          manifestId
        });

      case 9:
        i += 1;
        _context9.next = 4;
        break;

      case 12:
      case "end":
        return _context9.stop();
    }
  }, _marked9);
}
/** */

export default function iiifSaga() {
  return _regeneratorRuntime.wrap(function iiifSaga$(_context10) {
    while (1) switch (_context10.prev = _context10.next) {
      case 0:
        _context10.next = 2;
        return all([takeEvery(ActionTypes.REQUEST_MANIFEST, fetchManifest), takeEvery(ActionTypes.REQUEST_INFO_RESPONSE, fetchInfoResponse), takeEvery(ActionTypes.REQUEST_SEARCH, fetchSearchResponse), takeEvery(ActionTypes.REQUEST_ANNOTATION, fetchAnnotation), takeEvery(ActionTypes.ADD_RESOURCE, fetchResourceManifest)]);

      case 2:
      case "end":
        return _context10.stop();
    }
  }, _marked10);
}