import React, { Component, lazy, Suspense } from 'react';
import PluginProvider from '../extend/PluginProvider';
import AppProviders from '../containers/AppProviders';
const WorkspaceArea = /*#__PURE__*/lazy(() => import('../containers/WorkspaceArea'));
/**
 * This is the top level Mirador component.
 * @prop {Object} manifests
 */

export class App extends Component {
  /**
   * render
   * @return {String} - HTML markup for the component
   */
  render() {
    const _this$props = this.props,
          dndManager = _this$props.dndManager,
          plugins = _this$props.plugins;
    return /*#__PURE__*/React.createElement(PluginProvider, {
      plugins: plugins
    }, /*#__PURE__*/React.createElement(AppProviders, {
      dndManager: dndManager
    }, /*#__PURE__*/React.createElement(Suspense, {
      fallback: /*#__PURE__*/React.createElement("div", null)
    }, /*#__PURE__*/React.createElement(WorkspaceArea, null))));
  }

}
App.defaultProps = {
  dndManager: undefined,
  plugins: []
};
export default App;