import React, { Component } from 'react';
import Typography from '@material-ui/core/Typography';
import Link from '@material-ui/core/Link';
import Skeleton from '@material-ui/lab/Skeleton';
import { Img } from 'react-image';
import CompanionWindow from '../containers/CompanionWindow';
import { LabelValueMetadata } from './LabelValueMetadata';
import ns from '../config/css-ns';
import { PluginHook } from './PluginHook';
/**
 * WindowSideBarInfoPanel
 */

export class AttributionPanel extends Component {
  /**
   * render
   * @return
   */
  render() {
    const _this$props = this.props,
          manifestLogo = _this$props.manifestLogo,
          requiredStatement = _this$props.requiredStatement,
          rights = _this$props.rights,
          windowId = _this$props.windowId,
          id = _this$props.id,
          classes = _this$props.classes,
          t = _this$props.t;
    return /*#__PURE__*/React.createElement(CompanionWindow, {
      title: t('attributionTitle'),
      paperClassName: ns('attribution-panel'),
      windowId: windowId,
      id: id
    }, /*#__PURE__*/React.createElement("div", {
      className: classes.section
    }, requiredStatement && /*#__PURE__*/React.createElement(LabelValueMetadata, {
      labelValuePairs: requiredStatement,
      defaultLabel: t('attribution')
    }), rights && rights.length > 0 && /*#__PURE__*/React.createElement("dl", {
      className: ns('label-value-metadata')
    }, /*#__PURE__*/React.createElement(Typography, {
      variant: "subtitle2",
      component: "dt"
    }, t('rights')), rights.map(v => /*#__PURE__*/React.createElement(Typography, {
      variant: "body1",
      component: "dd",
      key: v.toString()
    }, /*#__PURE__*/React.createElement(Link, {
      target: "_blank",
      rel: "noopener noreferrer",
      href: v
    }, v))))), manifestLogo && /*#__PURE__*/React.createElement("div", {
      className: classes.section
    }, /*#__PURE__*/React.createElement(Img, {
      src: [manifestLogo],
      alt: "",
      role: "presentation",
      className: classes.logo,
      unloader: /*#__PURE__*/React.createElement(Skeleton, {
        className: classes.placeholder,
        variant: "rect",
        height: 60,
        width: 60
      })
    })), /*#__PURE__*/React.createElement(PluginHook, this.props));
  }

}
AttributionPanel.defaultProps = {
  classes: {},
  manifestLogo: null,
  requiredStatement: null,
  rights: null,
  t: key => key
};