import React, { Component } from 'react';
import Typography from '@material-ui/core/Typography';
import CollapsibleSection from '../containers/CollapsibleSection';
import SanitizedHtml from '../containers/SanitizedHtml';
import { LabelValueMetadata } from './LabelValueMetadata';
import { PluginHook } from './PluginHook';
/**
 * CanvasInfo
 */

export class CanvasInfo extends Component {
  /**
   * render
   * @return
   */
  render() {
    const _this$props = this.props,
          canvasDescription = _this$props.canvasDescription,
          canvasLabel = _this$props.canvasLabel,
          canvasMetadata = _this$props.canvasMetadata,
          id = _this$props.id,
          index = _this$props.index,
          t = _this$props.t,
          totalSize = _this$props.totalSize;
    return /*#__PURE__*/React.createElement(CollapsibleSection, {
      id: `${id}-currentItem-${index}`,
      label: t('currentItem', {
        context: `${index + 1}/${totalSize}`
      })
    }, canvasLabel && /*#__PURE__*/React.createElement(Typography, {
      "aria-labelledby": `${id}-currentItem-${index} ${id}-currentItem-${index}-heading`,
      id: `${id}-currentItem-${index}-heading`,
      variant: "h4",
      component: "h5"
    }, canvasLabel), canvasDescription && /*#__PURE__*/React.createElement(Typography, {
      variant: "body1"
    }, /*#__PURE__*/React.createElement(SanitizedHtml, {
      htmlString: canvasDescription,
      ruleSet: "iiif"
    })), canvasMetadata && canvasMetadata.length > 0 && /*#__PURE__*/React.createElement(LabelValueMetadata, {
      labelValuePairs: canvasMetadata
    }), /*#__PURE__*/React.createElement(PluginHook, this.props));
  }

}
CanvasInfo.defaultProps = {
  canvasDescription: null,
  canvasLabel: null,
  canvasMetadata: [],
  index: 1,
  t: key => key,
  totalSize: 1
};