import React, { Component } from 'react';
import Typography from '@material-ui/core/Typography';
import KeyboardArrowDown from '@material-ui/icons/KeyboardArrowDownSharp';
import KeyboardArrowUp from '@material-ui/icons/KeyboardArrowUpSharp';
import MiradorMenuButton from '../containers/MiradorMenuButton';
/**
 * CollapsableSection ~
*/

export class CollapsibleSection extends Component {
  /** */
  constructor(props) {
    super(props);
    this.state = {
      open: true
    };
    this.toggleSection = this.toggleSection.bind(this);
  }
  /** */


  toggleSection() {
    const open = this.state.open;
    this.setState({
      open: !open
    });
  }
  /**
   * Returns the rendered component
  */


  render() {
    const _this$props = this.props,
          children = _this$props.children,
          classes = _this$props.classes,
          id = _this$props.id,
          label = _this$props.label,
          t = _this$props.t;
    const open = this.state.open;
    return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
      className: classes.container
    }, /*#__PURE__*/React.createElement(Typography, {
      className: classes.heading,
      id: id,
      onClick: this.toggleSection,
      variant: "overline",
      component: "h4"
    }, label), /*#__PURE__*/React.createElement(MiradorMenuButton, {
      "aria-label": t(open ? 'collapseSection' : 'expandSection', {
        section: label
      }),
      "aria-expanded": open,
      className: classes.button,
      onClick: this.toggleSection
    }, open ? /*#__PURE__*/React.createElement(KeyboardArrowUp, null) : /*#__PURE__*/React.createElement(KeyboardArrowDown, null))), open && children);
  }

}