import React, { Component } from 'react';
import Button from '@material-ui/core/Button';
import Typography from '@material-ui/core/Typography';
import ViewListIcon from '@material-ui/icons/ViewListSharp';
import CollapsibleSection from '../containers/CollapsibleSection';
/**
 * ManifestInfo
 */

export class CollectionInfo extends Component {
  /** */
  constructor(props) {
    super(props);
    this.openCollectionDialog = this.openCollectionDialog.bind(this);
  }
  /** */


  openCollectionDialog() {
    const _this$props = this.props,
          collectionPath = _this$props.collectionPath,
          showCollectionDialog = _this$props.showCollectionDialog,
          windowId = _this$props.windowId;
    const manifestId = collectionPath[collectionPath.length - 1];
    showCollectionDialog(manifestId, collectionPath.slice(0, -1), windowId);
  }
  /**
   * render
   * @return
   */


  render() {
    const _this$props2 = this.props,
          collectionLabel = _this$props2.collectionLabel,
          collectionPath = _this$props2.collectionPath,
          id = _this$props2.id,
          t = _this$props2.t;
    if (collectionPath.length === 0) return null;
    return /*#__PURE__*/React.createElement(CollapsibleSection, {
      id: `${id}-collection`,
      label: t('collection')
    }, collectionLabel && /*#__PURE__*/React.createElement(Typography, {
      "aria-labelledby": `${id}-resource ${id}-resource-heading`,
      id: `${id}-resource-heading`,
      variant: "h4"
    }, collectionLabel), /*#__PURE__*/React.createElement(Button, {
      color: "primary",
      onClick: this.openCollectionDialog,
      startIcon: /*#__PURE__*/React.createElement(ViewListIcon, null)
    }, t('showCollection')));
  }

}
CollectionInfo.defaultProps = {
  collectionLabel: null,
  collectionPath: [],
  t: key => key,
  windowId: null
};