import React, { Component } from 'react';
import Slide from '@material-ui/core/Slide';
import ArrowLeftIcon from '@material-ui/icons/ArrowLeftSharp';
import ArrowRightIcon from '@material-ui/icons/ArrowRightSharp';
import CompanionWindowFactory from '../containers/CompanionWindowFactory';
import MiradorMenuButton from '../containers/MiradorMenuButton';
import ns from '../config/css-ns';
/** */

export class CompanionArea extends Component {
  /** */
  areaLayoutClass() {
    const _this$props = this.props,
          classes = _this$props.classes,
          position = _this$props.position;
    return position === 'bottom' || position === 'far-bottom' ? classes.horizontal : null;
  }
  /** */


  collapseIcon() {
    const _this$props2 = this.props,
          companionAreaOpen = _this$props2.companionAreaOpen,
          direction = _this$props2.direction;

    if (direction === 'rtl') {
      if (companionAreaOpen) return /*#__PURE__*/React.createElement(ArrowRightIcon, null);
      return /*#__PURE__*/React.createElement(ArrowLeftIcon, null);
    }

    if (companionAreaOpen) return /*#__PURE__*/React.createElement(ArrowLeftIcon, null);
    return /*#__PURE__*/React.createElement(ArrowRightIcon, null);
  }
  /** @private */


  slideDirection() {
    const _this$props3 = this.props,
          direction = _this$props3.direction,
          position = _this$props3.position;
    const defaultPosition = direction === 'rtl' ? 'left' : 'right';
    const oppositePosition = direction === 'rtl' ? 'right' : 'left';

    switch (position) {
      case 'right':
      case 'far-right':
        return oppositePosition;

      case 'bottom':
      case 'far-bottom':
        return 'up';

      default:
        return defaultPosition;
    }
  }
  /** */


  render() {
    const _this$props4 = this.props,
          classes = _this$props4.classes,
          companionWindowIds = _this$props4.companionWindowIds,
          companionAreaOpen = _this$props4.companionAreaOpen,
          setCompanionAreaOpen = _this$props4.setCompanionAreaOpen,
          position = _this$props4.position,
          sideBarOpen = _this$props4.sideBarOpen,
          t = _this$props4.t,
          windowId = _this$props4.windowId;
    return /*#__PURE__*/React.createElement("div", {
      className: [classes.root, this.areaLayoutClass(), ns(`companion-area-${position}`)].join(' ')
    }, /*#__PURE__*/React.createElement(Slide, {
      in: companionAreaOpen,
      direction: this.slideDirection()
    }, /*#__PURE__*/React.createElement("div", {
      className: [ns('companion-windows'), companionWindowIds.length > 0 && classes[position], this.areaLayoutClass()].join(' '),
      style: {
        display: companionAreaOpen ? 'flex' : 'none'
      }
    }, companionWindowIds.map(id => /*#__PURE__*/React.createElement(CompanionWindowFactory, {
      id: id,
      key: id,
      windowId: windowId
    })))), setCompanionAreaOpen && position === 'left' && sideBarOpen && companionWindowIds.length > 0 && /*#__PURE__*/React.createElement("div", {
      className: classes.toggle
    }, /*#__PURE__*/React.createElement(MiradorMenuButton, {
      "aria-expanded": companionAreaOpen,
      "aria-label": companionAreaOpen ? t('collapseSidePanel') : t('expandSidePanel'),
      className: classes.toggleButton,
      key: companionAreaOpen ? 'collapse' : 'expand',
      onClick: () => {
        setCompanionAreaOpen(windowId, !companionAreaOpen);
      },
      TooltipProps: {
        placement: 'right'
      }
    }, this.collapseIcon())));
  }

}
CompanionArea.defaultProps = {
  classes: {},
  setCompanionAreaOpen: () => {},
  sideBarOpen: false
};