import React, { Component } from 'react';
import ListItemIcon from '@material-ui/core/ListItemIcon';
import ListItemText from '@material-ui/core/ListItemText';
import MenuItem from '@material-ui/core/MenuItem';
import CheckIcon from '@material-ui/icons/CheckSharp';

/**
 * LanguageSettings ~ the workspace sub menu to change the language
 * of the application
*/
export class LanguageSettings extends Component {
  /**
   * Returns the rendered component
  */
  render() {
    const _this$props = this.props,
          handleClick = _this$props.handleClick,
          languages = _this$props.languages;
    return /*#__PURE__*/React.createElement(React.Fragment, null, languages.map(language => /*#__PURE__*/React.createElement(MenuItem, {
      button: !language.current,
      key: language.locale,
      onClick: () => {
        handleClick(language.locale);
      }
    }, /*#__PURE__*/React.createElement(ListItemIcon, null, language.current && /*#__PURE__*/React.createElement(CheckIcon, null)), /*#__PURE__*/React.createElement(ListItemText, {
      primaryTypographyProps: {
        variant: 'body1'
      }
    }, language.label))));
  }

}