import React, { Component } from 'react';
import CompanionWindow from '../containers/CompanionWindow';
import CanvasLayers from '../containers/CanvasLayers';
/**
 * a panel showing the canvases for a given manifest
 */

export class LayersPanel extends Component {
  /**
   * render
   */
  render() {
    const _this$props = this.props,
          canvasIds = _this$props.canvasIds,
          id = _this$props.id,
          t = _this$props.t,
          windowId = _this$props.windowId;
    return /*#__PURE__*/React.createElement(CompanionWindow, {
      title: t('layers'),
      id: id,
      windowId: windowId
    }, canvasIds.map((canvasId, index) => /*#__PURE__*/React.createElement(CanvasLayers, {
      canvasId: canvasId,
      index: index,
      key: canvasId,
      totalSize: canvasIds.length,
      windowId: windowId
    })));
  }

}
LayersPanel.defaultProps = {
  canvasIds: []
};