import React, { Component } from 'react';
import Typography from '@material-ui/core/Typography';
import CollapsibleSection from '../containers/CollapsibleSection';
import SanitizedHtml from '../containers/SanitizedHtml';
import { LabelValueMetadata } from './LabelValueMetadata';
import { PluginHook } from './PluginHook';
/**
 * ManifestInfo
 */

export class ManifestInfo extends Component {
  /**
   * render
   * @return
   */
  render() {
    const _this$props = this.props,
          manifestDescription = _this$props.manifestDescription,
          manifestLabel = _this$props.manifestLabel,
          manifestMetadata = _this$props.manifestMetadata,
          id = _this$props.id,
          t = _this$props.t;
    return /*#__PURE__*/React.createElement(CollapsibleSection, {
      id: `${id}-resource`,
      label: t('resource')
    }, manifestLabel && /*#__PURE__*/React.createElement(Typography, {
      "aria-labelledby": `${id}-resource ${id}-resource-heading`,
      id: `${id}-resource-heading`,
      variant: "h4",
      component: "h5"
    }, manifestLabel), manifestDescription && /*#__PURE__*/React.createElement(Typography, {
      variant: "body1"
    }, /*#__PURE__*/React.createElement(SanitizedHtml, {
      htmlString: manifestDescription,
      ruleSet: "iiif"
    })), manifestMetadata.length > 0 && /*#__PURE__*/React.createElement(LabelValueMetadata, {
      labelValuePairs: manifestMetadata
    }), /*#__PURE__*/React.createElement(PluginHook, this.props));
  }

}
ManifestInfo.defaultProps = {
  manifestDescription: null,
  manifestLabel: null,
  manifestMetadata: [],
  t: key => key
};