import React, { Component } from 'react';
import Button from '@material-ui/core/Button';
import ErrorIcon from '@material-ui/icons/ErrorOutlineSharp';
import Grid from '@material-ui/core/Grid';
import Typography from '@material-ui/core/Typography';
/**
 * ManifestListItemError renders a component displaying a
 * message to the user about a problem loading a manifest
*/

export class ManifestListItemError extends Component {
  /**
   * Returns the rendered component
  */
  render() {
    const _this$props = this.props,
          classes = _this$props.classes,
          manifestId = _this$props.manifestId,
          onDismissClick = _this$props.onDismissClick,
          onTryAgainClick = _this$props.onTryAgainClick,
          t = _this$props.t;
    return /*#__PURE__*/React.createElement(Grid, {
      container: true
    }, /*#__PURE__*/React.createElement(Grid, {
      container: true
    }, /*#__PURE__*/React.createElement(Grid, {
      container: true,
      item: true,
      xs: 12,
      sm: 6
    }, /*#__PURE__*/React.createElement(Grid, {
      item: true,
      xs: 4,
      sm: 3
    }, /*#__PURE__*/React.createElement(Grid, {
      container: true,
      justify: "center"
    }, /*#__PURE__*/React.createElement(ErrorIcon, {
      className: classes.errorIcon
    }))), /*#__PURE__*/React.createElement(Grid, {
      item: true,
      xs: 8,
      sm: 9
    }, /*#__PURE__*/React.createElement(Typography, null, t('manifestError')), /*#__PURE__*/React.createElement(Typography, {
      className: classes.manifestIdText
    }, manifestId)))), /*#__PURE__*/React.createElement(Grid, {
      container: true
    }, /*#__PURE__*/React.createElement(Grid, {
      container: true,
      item: true,
      xs: 12,
      sm: 6,
      justify: "flex-end"
    }, /*#__PURE__*/React.createElement(Grid, {
      item: true
    }, /*#__PURE__*/React.createElement(Button, {
      onClick: () => {
        onDismissClick(manifestId);
      }
    }, t('dismiss')), /*#__PURE__*/React.createElement(Button, {
      onClick: () => {
        onTryAgainClick(manifestId);
      }
    }, t('tryAgain'))))));
  }

}