import React, { Component } from 'react';
import MenuIcon from '@material-ui/icons/MenuSharp';
import cn from 'classnames';
import Paper from '@material-ui/core/Paper';
import AppBar from '@material-ui/core/AppBar';
import Toolbar from '@material-ui/core/Toolbar';
import Typography from '@material-ui/core/Typography';
import CloseIcon from '@material-ui/icons/CloseSharp';
import MiradorMenuButton from '../containers/MiradorMenuButton';
import ns from '../config/css-ns';
/** */

export class MinimalWindow extends Component {
  /** */
  render() {
    const _this$props = this.props,
          allowClose = _this$props.allowClose,
          allowWindowSideBar = _this$props.allowWindowSideBar,
          ariaLabel = _this$props.ariaLabel,
          children = _this$props.children,
          classes = _this$props.classes,
          label = _this$props.label,
          removeWindow = _this$props.removeWindow,
          t = _this$props.t,
          windowId = _this$props.windowId;
    return /*#__PURE__*/React.createElement(Paper, {
      component: "section",
      elevation: 1,
      id: windowId,
      className: cn(classes.window, ns('placeholder-window')),
      "aria-label": label && ariaLabel ? t('window', {
        label
      }) : null
    }, /*#__PURE__*/React.createElement(AppBar, {
      position: "relative",
      color: "default"
    }, /*#__PURE__*/React.createElement(Toolbar, {
      disableGutters: true,
      className: cn(classes.windowTopBarStyle, ns('window-top-bar')),
      variant: "dense"
    }, allowWindowSideBar && /*#__PURE__*/React.createElement(MiradorMenuButton, {
      "aria-label": t('toggleWindowSideBar'),
      disabled: true
    }, /*#__PURE__*/React.createElement(MenuIcon, null)), /*#__PURE__*/React.createElement(Typography, {
      variant: "h2",
      noWrap: true,
      color: "inherit",
      className: classes.title
    }, label), allowClose && removeWindow && /*#__PURE__*/React.createElement(MiradorMenuButton, {
      "aria-label": t('closeWindow'),
      className: cn(classes.button, ns('window-close')),
      onClick: removeWindow,
      TooltipProps: {
        tabIndex: ariaLabel ? '0' : '-1'
      }
    }, /*#__PURE__*/React.createElement(CloseIcon, null)))), children);
  }

}
MinimalWindow.defaultProps = {
  allowClose: true,
  allowWindowSideBar: true,
  ariaLabel: true,
  children: null,
  classes: {},
  label: '',
  removeWindow: () => {},
  t: key => key
};