function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { Component } from 'react';
import ListItemIcon from '@material-ui/core/ListItemIcon';
import ListItemText from '@material-ui/core/ListItemText';
import MenuItem from '@material-ui/core/MenuItem';
import ExpandLess from '@material-ui/icons/ExpandLessSharp';
import ExpandMore from '@material-ui/icons/ExpandMoreSharp';
/**
 * NestedMenu ~ A presentation component to render a menu item and have
 * it control the visibility of the MUI List passed in as the children
*/

export class NestedMenu extends Component {
  /**
   * constructor -
   */
  constructor(props) {
    super(props);
    this.state = {
      nestedMenuIsOpen: false
    };
    this.handleMenuClick = this.handleMenuClick.bind(this);
  }
  /**
   * handleMenuClick toggles the nestedMenuIsOpen state
   */


  handleMenuClick() {
    const nestedMenuIsOpen = this.state.nestedMenuIsOpen;
    this.setState({
      nestedMenuIsOpen: !nestedMenuIsOpen
    });
  }
  /**
   * Returns the rendered component.  Spreads unused props to MenuItem
  */


  render() {
    const nestedMenuIsOpen = this.state.nestedMenuIsOpen;

    const _this$props = this.props,
          children = _this$props.children,
          icon = _this$props.icon,
          label = _this$props.label,
          otherProps = _objectWithoutProperties(_this$props, ["children", "icon", "label"]);

    return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(MenuItem, Object.assign({
      onClick: this.handleMenuClick,
      divider: nestedMenuIsOpen
    }, otherProps), icon && /*#__PURE__*/React.createElement(ListItemIcon, null, icon), /*#__PURE__*/React.createElement(ListItemText, {
      primaryTypographyProps: {
        variant: 'body1'
      }
    }, label), nestedMenuIsOpen ? /*#__PURE__*/React.createElement(ExpandLess, null) : /*#__PURE__*/React.createElement(ExpandMore, null)), nestedMenuIsOpen && children);
  }

}
NestedMenu.defaultProps = {
  icon: null
};