import React, { Component } from 'react';
import DOMPurify from 'dompurify';
import ns from '../config/css-ns';
import htmlRules from '../lib/htmlRules';
/**
*/

export class SanitizedHtml extends Component {
  /**
  */
  render() {
    const _this$props = this.props,
          classes = _this$props.classes,
          htmlString = _this$props.htmlString,
          ruleSet = _this$props.ruleSet; // Add a hook to make all links open a new window

    DOMPurify.addHook('afterSanitizeAttributes', node => {
      // set all elements owning target to target=_blank
      if ('target' in node) {
        node.setAttribute('target', '_blank'); // prevent https://www.owasp.org/index.php/Reverse_Tabnabbing

        node.setAttribute('rel', 'noopener noreferrer');
      }
    });
    return /*#__PURE__*/React.createElement("span", {
      className: [classes.root, ns('third-party-html')].join(' '),
      dangerouslySetInnerHTML: {
        // eslint-disable-line react/no-danger
        __html: DOMPurify.sanitize(htmlString, htmlRules[ruleSet])
      }
    });
  }

}
SanitizedHtml.defaultProps = {
  classes: {}
};