import React, { Component } from 'react';
import ChevronLeftIcon from '@material-ui/icons/ChevronLeftSharp';
import ChevronRightIcon from '@material-ui/icons/ChevronRightSharp';
import Typography from '@material-ui/core/Typography';
import MiradorMenuButton from '../containers/MiradorMenuButton';
/**
 * SearchPanelNavigation ~
*/

export class SearchPanelNavigation extends Component {
  /** */
  nextSearchResult(currentHitIndex) {
    const _this$props = this.props,
          searchHits = _this$props.searchHits,
          selectAnnotation = _this$props.selectAnnotation;
    selectAnnotation(searchHits[currentHitIndex + 1].annotations[0]);
  }
  /** */


  previousSearchResult(currentHitIndex) {
    const _this$props2 = this.props,
          searchHits = _this$props2.searchHits,
          selectAnnotation = _this$props2.selectAnnotation;
    selectAnnotation(searchHits[currentHitIndex - 1].annotations[0]);
  }
  /** */


  hasNextResult(currentHitIndex) {
    const searchHits = this.props.searchHits;
    if (searchHits.length === 0) return false;
    if (currentHitIndex < searchHits.length - 1) return true;
    return false;
  }
  /** */


  hasPreviousResult(currentHitIndex) {
    const searchHits = this.props.searchHits;
    if (searchHits.length === 0) return false;
    if (currentHitIndex > 0) return true;
    return false;
  }
  /**
   * Returns the rendered component
  */


  render() {
    const _this$props3 = this.props,
          numTotal = _this$props3.numTotal,
          searchHits = _this$props3.searchHits,
          selectedContentSearchAnnotation = _this$props3.selectedContentSearchAnnotation,
          classes = _this$props3.classes,
          t = _this$props3.t,
          direction = _this$props3.direction;
    const iconStyle = direction === 'rtl' ? {
      transform: 'rotate(180deg)'
    } : {};
    const currentHitIndex = searchHits.findIndex(val => val.annotations.includes(selectedContentSearchAnnotation[0]));
    let lengthText = searchHits.length;

    if (searchHits.length < numTotal) {
      lengthText += '+';
    }

    return /*#__PURE__*/React.createElement(React.Fragment, null, searchHits.length > 0 && /*#__PURE__*/React.createElement(Typography, {
      variant: "body2",
      align: "center",
      classes: classes
    }, /*#__PURE__*/React.createElement(MiradorMenuButton, {
      "aria-label": t('searchPreviousResult'),
      disabled: !this.hasPreviousResult(currentHitIndex),
      onClick: () => this.previousSearchResult(currentHitIndex)
    }, /*#__PURE__*/React.createElement(ChevronLeftIcon, {
      style: iconStyle
    })), /*#__PURE__*/React.createElement("span", {
      style: {
        unicodeBidi: 'plaintext'
      }
    }, t('pagination', {
      current: currentHitIndex + 1,
      total: lengthText
    })), /*#__PURE__*/React.createElement(MiradorMenuButton, {
      "aria-label": t('searchNextResult'),
      disabled: !this.hasNextResult(currentHitIndex),
      onClick: () => this.nextSearchResult(currentHitIndex)
    }, /*#__PURE__*/React.createElement(ChevronRightIcon, {
      style: iconStyle
    }))));
  }

}
SearchPanelNavigation.defaultProps = {
  classes: {},
  numTotal: undefined,
  searchHits: [],
  t: key => key
};