function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React, { PureComponent } from 'react';
import classNames from 'classnames';
import IIIFThumbnail from '../containers/IIIFThumbnail';
import ns from '../config/css-ns';
/** */

export class ThumbnailCanvasGrouping extends PureComponent {
  /** */
  constructor(props) {
    super(props);
    this.setCanvas = this.setCanvas.bind(this);
  }
  /** */


  setCanvas(e) {
    const setCanvas = this.props.setCanvas;
    setCanvas(e.currentTarget.dataset.canvasId);
  }
  /**
   * Determines whether the current index is the rendered canvas, providing
   * a useful class.
   */


  currentCanvasClass(canvasIndices) {
    const index = this.props.index;
    if (canvasIndices.includes(index)) return 'current-canvas-grouping';
    return '';
  }
  /** */


  render() {
    const _this$props = this.props,
          index = _this$props.index,
          style = _this$props.style,
          data = _this$props.data,
          classes = _this$props.classes,
          currentCanvasId = _this$props.currentCanvasId;
    const canvasGroupings = data.canvasGroupings,
          position = data.position,
          height = data.height;
    const currentGroupings = canvasGroupings[index];
    const SPACING = 8;
    return /*#__PURE__*/React.createElement("div", {
      style: _objectSpread(_objectSpread({}, style), {}, {
        boxSizing: 'content-box',
        height: Number.isInteger(style.height) ? style.height - SPACING : null,
        left: style.left + SPACING,
        top: style.top + SPACING,
        width: Number.isInteger(style.width) ? style.width - SPACING : null
      }),
      className: ns('thumbnail-nav-container'),
      role: "gridcell",
      "aria-colindex": index + 1
    }, /*#__PURE__*/React.createElement("div", {
      role: "button",
      "data-canvas-id": currentGroupings[0].id,
      "data-canvas-index": currentGroupings[0].index,
      onKeyUp: this.setCanvas,
      onClick: this.setCanvas,
      tabIndex: -1,
      style: {
        height: position === 'far-right' ? 'auto' : `${height - SPACING}px`,
        width: position === 'far-bottom' ? 'auto' : `${style.width}px`
      },
      className: classNames(ns(['thumbnail-nav-canvas', `thumbnail-nav-canvas-${index}`, this.currentCanvasClass(currentGroupings.map(canvas => canvas.index))]), classes.canvas, {
        [classes.currentCanvas]: currentGroupings.map(canvas => canvas.id).includes(currentCanvasId)
      })
    }, currentGroupings.map((canvas, i) => /*#__PURE__*/React.createElement(IIIFThumbnail, {
      key: canvas.id,
      resource: canvas,
      labelled: true,
      maxHeight: position === 'far-right' ? style.height - 1.5 * SPACING : height - 1.5 * SPACING,
      variant: "inside"
    }))));
  }

}