import React, { Component } from 'react';
import NavigationIcon from '@material-ui/icons/PlayCircleOutlineSharp';
import classNames from 'classnames';
import MiradorMenuButton from '../containers/MiradorMenuButton';
import ns from '../config/css-ns';
/**
 */

export class ViewerNavigation extends Component {
  /**
   * Renders things
   */
  render() {
    const _this$props = this.props,
          hasNextCanvas = _this$props.hasNextCanvas,
          hasPreviousCanvas = _this$props.hasPreviousCanvas,
          setNextCanvas = _this$props.setNextCanvas,
          setPreviousCanvas = _this$props.setPreviousCanvas,
          t = _this$props.t,
          classes = _this$props.classes,
          viewingDirection = _this$props.viewingDirection;
    let htmlDir = 'ltr';
    let previousIconStyle = {};
    let nextIconStyle = {};

    switch (viewingDirection) {
      case 'top-to-bottom':
        previousIconStyle = {
          transform: 'rotate(270deg)'
        };
        nextIconStyle = {
          transform: 'rotate(90deg)'
        };
        break;

      case 'bottom-to-top':
        previousIconStyle = {
          transform: 'rotate(90deg)'
        };
        nextIconStyle = {
          transform: 'rotate(270deg)'
        };
        break;

      case 'right-to-left':
        htmlDir = 'rtl';
        previousIconStyle = {};
        nextIconStyle = {
          transform: 'rotate(180deg)'
        };
        break;

      default:
        previousIconStyle = {
          transform: 'rotate(180deg)'
        };
        nextIconStyle = {};
    }

    return /*#__PURE__*/React.createElement("div", {
      className: classNames(ns('osd-navigation'), classes.osdNavigation),
      dir: htmlDir
    }, /*#__PURE__*/React.createElement(MiradorMenuButton, {
      "aria-label": t('previousCanvas'),
      className: ns('previous-canvas-button'),
      disabled: !hasPreviousCanvas,
      onClick: () => {
        hasPreviousCanvas && setPreviousCanvas();
      }
    }, /*#__PURE__*/React.createElement(NavigationIcon, {
      style: previousIconStyle
    })), /*#__PURE__*/React.createElement(MiradorMenuButton, {
      "aria-label": t('nextCanvas'),
      className: ns('next-canvas-button'),
      disabled: !hasNextCanvas,
      onClick: () => {
        hasNextCanvas && setNextCanvas();
      }
    }, /*#__PURE__*/React.createElement(NavigationIcon, {
      style: nextIconStyle
    })));
  }

}
ViewerNavigation.defaultProps = {
  hasNextCanvas: false,
  hasPreviousCanvas: false,
  setNextCanvas: () => {},
  setPreviousCanvas: () => {},
  viewingDirection: ''
};