import React, { Component } from 'react';
import Menu from '@material-ui/core/Menu';
import MenuItem from '@material-ui/core/MenuItem';
import ListItemText from '@material-ui/core/ListItemText';
import ListSubheader from '@material-ui/core/ListSubheader';
import ns from '../config/css-ns';
/**
 */

export class WindowList extends Component {
  /**
   * Given the menuElement passed in by the onEntering callback,
   * find the 2nd ListItem element (avoiding the header) and focus it
  */
  static focus2ndListIitem(menuElement) {
    if (!menuElement.querySelectorAll('li') || menuElement.querySelectorAll('li').length < 2) return;
    menuElement.querySelectorAll('li')[1].focus(); // The 2nd LI
  }
  /**
   * Get the title for a window from its manifest title
   * @private
   */


  titleContent(windowId) {
    const _this$props = this.props,
          titles = _this$props.titles,
          t = _this$props.t;
    return titles[windowId] || t('untitled');
  }
  /**
   * render
   * @return
   */


  render() {
    const _this$props2 = this.props,
          containerId = _this$props2.containerId,
          handleClose = _this$props2.handleClose,
          anchorEl = _this$props2.anchorEl,
          windowIds = _this$props2.windowIds,
          focusWindow = _this$props2.focusWindow,
          t = _this$props2.t;
    return /*#__PURE__*/React.createElement(Menu, {
      anchorOrigin: {
        horizontal: 'right',
        vertical: 'top'
      },
      transformOrigin: {
        horizontal: 'left',
        vertical: 'top'
      },
      id: "window-list-menu",
      container: document.querySelector(`#${containerId} .${ns('viewer')}`),
      disableAutoFocusItem: true,
      anchorEl: anchorEl,
      open: Boolean(anchorEl),
      onClose: handleClose,
      onEntering: WindowList.focus2ndListIitem
    }, /*#__PURE__*/React.createElement(ListSubheader, {
      role: "presentation",
      selected: false,
      disabled: true,
      tabIndex: "-1"
    }, t('openWindows')), windowIds.map((windowId, i) => /*#__PURE__*/React.createElement(MenuItem, {
      key: windowId,
      onClick: e => {
        focusWindow(windowId, true);
        handleClose(e);
      }
    }, /*#__PURE__*/React.createElement(ListItemText, {
      primaryTypographyProps: {
        variant: 'body1'
      }
    }, this.titleContent(windowId)))));
  }

}
WindowList.defaultProps = {
  anchorEl: null,
  t: key => key,
  titles: {}
};