import React, { Component } from 'react';
import BookmarksIcon from '@material-ui/icons/BookmarksSharp';
import classNames from 'classnames';
import WindowList from '../containers/WindowList';
import MiradorMenuButton from '../containers/MiradorMenuButton';
/**
 * WindowListButton ~
*/

export class WindowListButton extends Component {
  /** */
  constructor(props) {
    super(props);
    this.state = {
      windowListAnchor: null
    };
    this.handleClose = this.handleClose.bind(this);
    this.handleOpen = this.handleOpen.bind(this);
  }
  /** Set the windowListAnchor to null on window close */


  handleClose() {
    this.setState({
      windowListAnchor: null
    });
  }
  /** Set the windowListAnchor to the event's current target  */


  handleOpen(event) {
    this.setState({
      windowListAnchor: event.currentTarget
    });
  }
  /**
   * Returns the rendered component
  */


  render() {
    const _this$props = this.props,
          classes = _this$props.classes,
          disabled = _this$props.disabled,
          t = _this$props.t,
          windowCount = _this$props.windowCount;
    const windowListAnchor = this.state.windowListAnchor;
    return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(MiradorMenuButton, {
      "aria-haspopup": "true",
      "aria-label": t('listAllOpenWindows'),
      "aria-owns": windowListAnchor ? 'window-list' : null,
      className: classNames(classes.ctrlBtn, windowListAnchor ? classes.ctrlBtnSelected : null),
      disabled: disabled,
      badge: true,
      BadgeProps: {
        badgeContent: windowCount,
        classes: {
          badge: classes.badge
        }
      },
      onClick: e => this.handleOpen(e)
    }, /*#__PURE__*/React.createElement(BookmarksIcon, null)), Boolean(windowListAnchor) && /*#__PURE__*/React.createElement(WindowList, {
      anchorEl: windowListAnchor,
      id: "window-list",
      open: Boolean(windowListAnchor),
      handleClose: this.handleClose
    }));
  }

}
WindowListButton.defaultProps = {
  classes: {},
  disabled: false
};