import React, { Component } from 'react';
import classNames from 'classnames';
import Drawer from '@material-ui/core/Drawer';
import WindowSideBarButtons from '../containers/WindowSideBarButtons';
/**
 * WindowSideBar
 */

export class WindowSideBar extends Component {
  /**
   * render
   * @return
   */
  render() {
    const _this$props = this.props,
          classes = _this$props.classes,
          direction = _this$props.direction,
          t = _this$props.t,
          windowId = _this$props.windowId,
          sideBarOpen = _this$props.sideBarOpen;
    return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Drawer, {
      variant: "persistent",
      className: classNames(classes.drawer),
      classes: {
        paper: classNames(classes.paper)
      },
      anchor: direction === 'rtl' ? 'right' : 'left',
      PaperProps: {
        'aria-label': t('sidebarPanelsNavigation'),
        component: 'nav',
        style: {
          height: '100%',
          position: 'relative'
        }
      },
      SlideProps: {
        direction: direction === 'rtl' ? 'left' : 'right',
        mountOnEnter: true,
        unmountOnExit: true
      },
      open: sideBarOpen
    }, /*#__PURE__*/React.createElement(WindowSideBarButtons, {
      windowId: windowId
    })));
  }

}
WindowSideBar.defaultProps = {
  sideBarOpen: false
};