import React, { Component } from 'react';
import Badge from '@material-ui/core/Badge';
import Tabs from '@material-ui/core/Tabs';
import Tab from '@material-ui/core/Tab';
import Tooltip from '@material-ui/core/Tooltip';
import InfoIcon from '@material-ui/icons/InfoSharp';
import AnnotationIcon from '@material-ui/icons/CommentSharp';
import AttributionIcon from '@material-ui/icons/CopyrightSharp';
import LayersIcon from '@material-ui/icons/LayersSharp';
import SearchIcon from '@material-ui/icons/SearchSharp';
import CanvasIndexIcon from './icons/CanvasIndexIcon';
/**
 *
 */

export class WindowSideBarButtons extends Component {
  /** */
  constructor(props) {
    super(props);
    this.handleChange = this.handleChange.bind(this);
  }
  /**
   * @param {object} event the change event
   * @param {string} value the tab's value
  */


  handleChange(event, value) {
    const addCompanionWindow = this.props.addCompanionWindow;
    addCompanionWindow(value);
  }
  /**
   * render
   *
   * @return {type}  description
   */


  render() {
    const _this$props = this.props,
          classes = _this$props.classes,
          hasAnnotations = _this$props.hasAnnotations,
          hasAnyAnnotations = _this$props.hasAnyAnnotations,
          hasAnyLayers = _this$props.hasAnyLayers,
          hasCurrentLayers = _this$props.hasCurrentLayers,
          hasSearchResults = _this$props.hasSearchResults,
          hasSearchService = _this$props.hasSearchService,
          panels = _this$props.panels,
          PluginComponents = _this$props.PluginComponents,
          sideBarPanel = _this$props.sideBarPanel,
          t = _this$props.t;
    /** */

    const TabButton = props => /*#__PURE__*/React.createElement(Tooltip, {
      title: t('openCompanionWindow', {
        context: props.value
      })
    }, /*#__PURE__*/React.createElement(Tab, Object.assign({}, props, {
      classes: {
        root: classes.tab,
        selected: classes.tabSelected
      },
      "aria-label": t('openCompanionWindow', {
        context: props.value
      }),
      disableRipple: true,
      onKeyUp: this.handleKeyUp
    })));

    return /*#__PURE__*/React.createElement(Tabs, {
      classes: {
        flexContainer: classes.tabsFlexContainer,
        indicator: classes.tabsIndicator
      },
      value: sideBarPanel === 'closed' ? false : sideBarPanel,
      onChange: this.handleChange,
      variant: "fullWidth",
      indicatorColor: "primary",
      textColor: "primary",
      orientation: "vertical",
      "aria-orientation": "vertical",
      "aria-label": t('sidebarPanelsNavigation')
    }, panels.info && /*#__PURE__*/React.createElement(TabButton, {
      value: "info",
      icon: /*#__PURE__*/React.createElement(InfoIcon, null)
    }), panels.attribution && /*#__PURE__*/React.createElement(TabButton, {
      value: "attribution",
      icon: /*#__PURE__*/React.createElement(AttributionIcon, null)
    }), panels.canvas && /*#__PURE__*/React.createElement(TabButton, {
      value: "canvas",
      icon: /*#__PURE__*/React.createElement(CanvasIndexIcon, null)
    }), panels.annotations && (hasAnnotations || hasAnyAnnotations) && /*#__PURE__*/React.createElement(TabButton, {
      value: "annotations",
      icon: /*#__PURE__*/React.createElement(Badge, {
        classes: {
          badge: classes.badge
        },
        invisible: !hasAnnotations,
        variant: "dot"
      }, /*#__PURE__*/React.createElement(AnnotationIcon, null))
    }), panels.search && hasSearchService && /*#__PURE__*/React.createElement(TabButton, {
      value: "search",
      icon: /*#__PURE__*/React.createElement(Badge, {
        classes: {
          badge: classes.badge
        },
        invisible: !hasSearchResults,
        variant: "dot"
      }, /*#__PURE__*/React.createElement(SearchIcon, null))
    }), panels.layers && hasAnyLayers && /*#__PURE__*/React.createElement(TabButton, {
      value: "layers",
      icon: /*#__PURE__*/React.createElement(Badge, {
        classes: {
          badge: classes.badge
        },
        invisible: !hasCurrentLayers,
        variant: "dot"
      }, /*#__PURE__*/React.createElement(LayersIcon, null))
    }), PluginComponents && PluginComponents.map(PluginComponent => /*#__PURE__*/React.createElement(TabButton, {
      key: PluginComponent.value,
      value: PluginComponent.value,
      icon: /*#__PURE__*/React.createElement(PluginComponent, null)
    })));
  }

}
WindowSideBarButtons.defaultProps = {
  classes: {},
  hasAnnotations: false,
  hasAnyAnnotations: false,
  hasAnyLayers: false,
  hasCurrentLayers: false,
  hasSearchResults: false,
  hasSearchService: false,
  panels: [],
  PluginComponents: null,
  sideBarPanel: 'closed',
  t: key => key
};