function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { Component } from 'react';
import List from '@material-ui/core/List';
import ListItem from '@material-ui/core/ListItem';
import ListItemIcon from '@material-ui/core/ListItemIcon';
import ListItemText from '@material-ui/core/ListItemText';
import MenuList from '@material-ui/core/MenuList';
import MenuItem from '@material-ui/core/MenuItem';
import Typography from '@material-ui/core/Typography';
import Skeleton from '@material-ui/lab/Skeleton';
import ArrowUpwardIcon from '@material-ui/icons/ArrowUpwardSharp';
import CompanionWindow from '../containers/CompanionWindow';
import IIIFThumbnail from '../containers/IIIFThumbnail';
/** */

export class WindowSideBarCollectionPanel extends Component {
  /** */
  static getUseableLabel(resource, index) {
    return resource && resource.getLabel && resource.getLabel().length > 0 ? resource.getLabel().getValue() : resource.id;
  }
  /** */


  isMultipart() {
    const collection = this.props.collection;
    if (!collection) return false;
    const behaviors = collection.getProperty('behavior');
    if (Array.isArray(behaviors)) return collection.includes('multi-part');
    return behaviors === 'multi-part';
  }
  /** */


  render() {
    const _this$props = this.props,
          canvasNavigation = _this$props.canvasNavigation,
          classes = _this$props.classes,
          collectionPath = _this$props.collectionPath,
          collection = _this$props.collection,
          id = _this$props.id,
          isFetching = _this$props.isFetching,
          manifestId = _this$props.manifestId,
          parentCollection = _this$props.parentCollection,
          updateCompanionWindow = _this$props.updateCompanionWindow,
          updateWindow = _this$props.updateWindow,
          t = _this$props.t,
          variant = _this$props.variant,
          windowId = _this$props.windowId;
    /** */

    const Item = (_ref) => {
      let manifest = _ref.manifest,
          otherProps = _objectWithoutProperties(_ref, ["manifest"]);

      return /*#__PURE__*/React.createElement(MenuItem, Object.assign({
        className: classes.menuItem,
        alignItems: "flex-start",
        button: true,
        component: "li",
        selected: manifestId === manifest.id
      }, otherProps), variant === 'thumbnail' && /*#__PURE__*/React.createElement(ListItemIcon, null, /*#__PURE__*/React.createElement(IIIFThumbnail, {
        resource: manifest,
        maxHeight: canvasNavigation.height,
        maxWidth: canvasNavigation.width
      })), /*#__PURE__*/React.createElement(ListItemText, null, WindowSideBarCollectionPanel.getUseableLabel(manifest)));
    };

    return /*#__PURE__*/React.createElement(CompanionWindow, {
      title: t(this.isMultipart() ? 'multipartCollection' : 'collection'),
      windowId: windowId,
      id: id,
      titleControls: /*#__PURE__*/React.createElement(React.Fragment, null, parentCollection && /*#__PURE__*/React.createElement(List, null, /*#__PURE__*/React.createElement(ListItem, {
        button: true,
        onClick: () => updateCompanionWindow({
          collectionPath: collectionPath.slice(0, -1)
        })
      }, /*#__PURE__*/React.createElement(ListItemIcon, null, /*#__PURE__*/React.createElement(ArrowUpwardIcon, null)), /*#__PURE__*/React.createElement(ListItemText, {
        primaryTypographyProps: {
          variant: 'body1'
        }
      }, WindowSideBarCollectionPanel.getUseableLabel(parentCollection)))), /*#__PURE__*/React.createElement(Typography, {
        variant: "h6"
      }, collection && WindowSideBarCollectionPanel.getUseableLabel(collection), isFetching && /*#__PURE__*/React.createElement(Skeleton, {
        className: classes.placeholder,
        variant: "text"
      })))
    }, /*#__PURE__*/React.createElement(MenuList, null, isFetching && /*#__PURE__*/React.createElement(MenuItem, null, /*#__PURE__*/React.createElement(ListItemText, null, /*#__PURE__*/React.createElement(Skeleton, {
      className: classes.placeholder,
      variant: "text"
    }), /*#__PURE__*/React.createElement(Skeleton, {
      className: classes.placeholder,
      variant: "text"
    }), /*#__PURE__*/React.createElement(Skeleton, {
      className: classes.placeholder,
      variant: "text"
    }))), collection && collection.getCollections().map(manifest => {
      /** select the new manifest and go back to the normal index */
      const onClick = () => {
        // close collection
        updateCompanionWindow({
          collectionPath: [...collectionPath, manifest.id]
        });
      };

      return /*#__PURE__*/React.createElement(Item, {
        key: manifest.id,
        onClick: onClick,
        manifest: manifest
      });
    }), collection && collection.getManifests().map(manifest => {
      /** select the new manifest and go back to the normal index */
      const onClick = () => {
        // select new manifest
        updateWindow({
          canvasId: null,
          collectionPath,
          manifestId: manifest.id
        }); // close collection

        updateCompanionWindow({
          multipart: false
        });
      };

      return /*#__PURE__*/React.createElement(Item, {
        key: manifest.id,
        onClick: onClick,
        manifest: manifest
      });
    })));
  }

}
WindowSideBarCollectionPanel.defaultProps = {
  collection: null,
  collectionPath: [],
  error: null,
  isFetching: false,
  parentCollection: null,
  ready: false,
  t: k => k,
  variant: null
};