import React, { Component } from 'react';
import MenuIcon from '@material-ui/icons/MenuSharp';
import CloseIcon from '@material-ui/icons/CloseSharp';
import Toolbar from '@material-ui/core/Toolbar';
import AppBar from '@material-ui/core/AppBar';
import classNames from 'classnames';
import WindowTopMenuButton from '../containers/WindowTopMenuButton';
import WindowTopBarPluginArea from '../containers/WindowTopBarPluginArea';
import WindowTopBarPluginMenu from '../containers/WindowTopBarPluginMenu';
import WindowTopBarTitle from '../containers/WindowTopBarTitle';
import MiradorMenuButton from '../containers/MiradorMenuButton';
import FullScreenButton from '../containers/FullScreenButton';
import WindowMaxIcon from './icons/WindowMaxIcon';
import WindowMinIcon from './icons/WindowMinIcon';
import ns from '../config/css-ns';
/**
 * WindowTopBar
 */

export class WindowTopBar extends Component {
  /**
   * render
   * @return
   */
  render() {
    const _this$props = this.props,
          removeWindow = _this$props.removeWindow,
          windowId = _this$props.windowId,
          classes = _this$props.classes,
          toggleWindowSideBar = _this$props.toggleWindowSideBar,
          t = _this$props.t,
          windowDraggable = _this$props.windowDraggable,
          maximizeWindow = _this$props.maximizeWindow,
          maximized = _this$props.maximized,
          minimizeWindow = _this$props.minimizeWindow,
          focused = _this$props.focused,
          allowClose = _this$props.allowClose,
          allowMaximize = _this$props.allowMaximize,
          focusWindow = _this$props.focusWindow,
          allowFullscreen = _this$props.allowFullscreen,
          allowTopMenuButton = _this$props.allowTopMenuButton,
          allowWindowSideBar = _this$props.allowWindowSideBar;
    return /*#__PURE__*/React.createElement(AppBar, {
      position: "relative",
      color: "default"
    }, /*#__PURE__*/React.createElement("nav", {
      "aria-label": t('windowNavigation')
    }, /*#__PURE__*/React.createElement(Toolbar, {
      disableGutters: true,
      onMouseDown: focusWindow,
      className: classNames(classes.windowTopBarStyle, windowDraggable ? classes.windowTopBarStyleDraggable : null, focused ? classes.focused : null, ns('window-top-bar')),
      variant: "dense"
    }, allowWindowSideBar && /*#__PURE__*/React.createElement(MiradorMenuButton, {
      "aria-label": t('toggleWindowSideBar'),
      onClick: toggleWindowSideBar
    }, /*#__PURE__*/React.createElement(MenuIcon, null)), /*#__PURE__*/React.createElement(WindowTopBarTitle, {
      windowId: windowId
    }), allowTopMenuButton && /*#__PURE__*/React.createElement(WindowTopMenuButton, {
      className: ns('window-menu-btn'),
      windowId: windowId
    }), /*#__PURE__*/React.createElement(WindowTopBarPluginArea, {
      windowId: windowId
    }), /*#__PURE__*/React.createElement(WindowTopBarPluginMenu, {
      windowId: windowId
    }), allowMaximize && /*#__PURE__*/React.createElement(MiradorMenuButton, {
      "aria-label": maximized ? t('minimizeWindow') : t('maximizeWindow'),
      className: ns('window-maximize'),
      onClick: maximized ? minimizeWindow : maximizeWindow
    }, maximized ? /*#__PURE__*/React.createElement(WindowMinIcon, null) : /*#__PURE__*/React.createElement(WindowMaxIcon, null)), allowFullscreen && /*#__PURE__*/React.createElement(FullScreenButton, null), allowClose && /*#__PURE__*/React.createElement(MiradorMenuButton, {
      "aria-label": t('closeWindow'),
      className: ns('window-close'),
      onClick: removeWindow
    }, /*#__PURE__*/React.createElement(CloseIcon, null)))));
  }

}
WindowTopBar.defaultProps = {
  allowClose: true,
  allowFullscreen: false,
  allowMaximize: true,
  allowTopMenuButton: true,
  allowWindowSideBar: true,
  focused: false,
  focusWindow: () => {},
  maximized: false,
  maximizeWindow: () => {},
  minimizeWindow: () => {},
  t: key => key,
  windowDraggable: true
};