import React, { Component } from 'react';
import Typography from '@material-ui/core/Typography';
import Skeleton from '@material-ui/lab/Skeleton';
import ErrorIcon from '@material-ui/icons/ErrorOutlineSharp';
/**
 * WindowTopBarTitle
 */

export class WindowTopBarTitle extends Component {
  /**
   * render
   * @return
   */
  render() {
    const _this$props = this.props,
          classes = _this$props.classes,
          error = _this$props.error,
          hideWindowTitle = _this$props.hideWindowTitle,
          isFetching = _this$props.isFetching,
          manifestTitle = _this$props.manifestTitle;
    /** */

    const TitleTypography = props => /*#__PURE__*/React.createElement(Typography, Object.assign({
      variant: "h2",
      noWrap: true,
      color: "inherit",
      className: classes.title
    }, props), props.children);

    let title = null;

    if (isFetching) {
      title = /*#__PURE__*/React.createElement(TitleTypography, null, /*#__PURE__*/React.createElement(Skeleton, {
        variant: "text"
      }));
    } else if (error) {
      title = /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(ErrorIcon, {
        color: "error"
      }), /*#__PURE__*/React.createElement(TitleTypography, {
        color: "textSecondary"
      }, error));
    } else if (hideWindowTitle) {
      title = /*#__PURE__*/React.createElement("div", {
        className: classes.title
      });
    } else {
      title = /*#__PURE__*/React.createElement(TitleTypography, null, manifestTitle);
    }

    return title;
  }

}
WindowTopBarTitle.defaultProps = {
  error: null,
  hideWindowTitle: false,
  isFetching: false,
  manifestTitle: ''
};