import React, { Component } from 'react';
import WindowTopMenu from '../containers/WindowTopMenu';
import MiradorMenuButton from '../containers/MiradorMenuButton';
import WindowOptionsIcon from './icons/WindowOptionsIcon';
/**
 */

export class WindowTopMenuButton extends Component {
  /**
   * constructor -
   */
  constructor(props) {
    super(props);
    this.state = {
      anchorEl: null
    };
    this.handleMenuClick = this.handleMenuClick.bind(this);
    this.handleMenuClose = this.handleMenuClose.bind(this);
  }
  /**
   * @private
   */


  handleMenuClick(event) {
    this.setState({
      anchorEl: event.currentTarget
    });
  }
  /**
   * @private
   */


  handleMenuClose() {
    this.setState({
      anchorEl: null
    });
  }
  /**
   * render
   * @return
   */


  render() {
    const _this$props = this.props,
          classes = _this$props.classes,
          t = _this$props.t,
          windowId = _this$props.windowId;
    const anchorEl = this.state.anchorEl;
    return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(MiradorMenuButton, {
      "aria-haspopup": "true",
      "aria-label": t('windowMenu'),
      "aria-owns": anchorEl ? `window-menu_${windowId}` : undefined,
      className: anchorEl ? classes.ctrlBtnSelected : null,
      onClick: this.handleMenuClick
    }, /*#__PURE__*/React.createElement(WindowOptionsIcon, null)), /*#__PURE__*/React.createElement(WindowTopMenu, {
      windowId: windowId,
      anchorEl: anchorEl,
      handleClose: this.handleMenuClose
    }));
  }

}
WindowTopMenuButton.defaultProps = {
  t: key => key
};