import React, { Component } from 'react';
import classNames from 'classnames';
import AppBar from '@material-ui/core/AppBar';
import Toolbar from '@material-ui/core/Toolbar';
import WorkspaceAddButton from '../containers/WorkspaceAddButton';
import WorkspaceControlPanelButtons from '../containers/WorkspaceControlPanelButtons';
import Branding from '../containers/Branding';
import ns from '../config/css-ns';
/**
 * Provides the panel responsible for controlling the entire workspace
 */

export class WorkspaceControlPanel extends Component {
  /**
   * render
   * @return {String} - HTML markup for the component
   */
  render() {
    const _this$props = this.props,
          classes = _this$props.classes,
          t = _this$props.t,
          variant = _this$props.variant;
    return /*#__PURE__*/React.createElement(AppBar, {
      className: classNames(classes.root, ns('workspace-control-panel'), variant === 'wide' ? classes.wide : null),
      color: "default",
      position: "absolute",
      component: "nav",
      "aria-label": t('workspaceNavigation')
    }, /*#__PURE__*/React.createElement(Toolbar, {
      disableGutters: true,
      className: classes.toolbar
    }, /*#__PURE__*/React.createElement(WorkspaceAddButton, null), /*#__PURE__*/React.createElement("div", {
      className: classes.workspaceButtons
    }, /*#__PURE__*/React.createElement(WorkspaceControlPanelButtons, null))), /*#__PURE__*/React.createElement(Branding, {
      className: classes.branding,
      t: t,
      variant: variant
    }));
  }

}
WorkspaceControlPanel.defaultProps = {
  variant: 'default'
};