import React, { Component } from 'react';
import SettingsIcon from '@material-ui/icons/SettingsSharp';
import classNames from 'classnames';
import WorkspaceMenu from '../containers/WorkspaceMenu';
import MiradorMenuButton from '../containers/MiradorMenuButton';
/**
 */

export class WorkspaceMenuButton extends Component {
  /**
   * constructor -
   */
  constructor(props) {
    super(props);
    this.state = {
      anchorEl: null
    };
    this.handleMenuClick = this.handleMenuClick.bind(this);
    this.handleMenuClose = this.handleMenuClose.bind(this);
  }
  /**
   * @private
   */


  handleMenuClick(event) {
    this.setState({
      anchorEl: event.currentTarget
    });
  }
  /**
   * @private
   */


  handleMenuClose() {
    this.setState({
      anchorEl: null
    });
  }
  /**
   * render
   * @return
   */


  render() {
    const _this$props = this.props,
          classes = _this$props.classes,
          t = _this$props.t;
    const anchorEl = this.state.anchorEl;
    return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(MiradorMenuButton, {
      "aria-haspopup": "true",
      "aria-label": t('workspaceMenu'),
      "aria-owns": anchorEl ? 'workspace-menu' : undefined,
      className: classNames(classes.ctrlBtn, anchorEl ? classes.ctrlBtnSelected : null),
      id: "menuBtn",
      onClick: this.handleMenuClick
    }, /*#__PURE__*/React.createElement(SettingsIcon, null)), /*#__PURE__*/React.createElement(WorkspaceMenu, {
      anchorEl: anchorEl,
      handleClose: this.handleMenuClose
    }));
  }

}
WorkspaceMenuButton.defaultProps = {
  t: key => key
};