function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import { compose } from 'redux';
import { connect } from 'react-redux';
import { withTranslation } from 'react-i18next';
import { withStyles } from '@material-ui/core/styles';
import { withPlugins } from '../extend/withPlugins';
import { SearchResults } from '../components/SearchResults';
import * as actions from '../state/actions';
import { getNextSearchId, getSearchQuery, getSearchIsFetching, getSearchNumTotal, getSortedSearchHitsForCompanionWindow, getSortedSearchAnnotationsForCompanionWindow } from '../state/selectors';
/**
 * mapStateToProps - used to hook up connect to state
 * @memberof SearchResult
 * @private
 */

const mapStateToProps = (state, {
  companionWindowId,
  windowId
}) => ({
  isFetching: getSearchIsFetching(state, {
    companionWindowId,
    windowId
  }),
  nextSearch: getNextSearchId(state, {
    companionWindowId,
    windowId
  }),
  query: getSearchQuery(state, {
    companionWindowId,
    windowId
  }),
  searchAnnotations: getSortedSearchAnnotationsForCompanionWindow(state, {
    companionWindowId,
    windowId
  }),
  searchHits: getSortedSearchHitsForCompanionWindow(state, {
    companionWindowId,
    windowId
  }),
  searchNumTotal: getSearchNumTotal(state, {
    companionWindowId,
    windowId
  })
});

const mapDispatchToProps = {
  fetchSearch: actions.fetchSearch
};
/** */

const styles = theme => ({
  moreButton: {
    width: '100%'
  },
  navigation: {
    textTransform: 'none'
  },
  noResults: _objectSpread(_objectSpread({}, theme.typography.h6), {}, {
    padding: theme.spacing(2)
  }),
  toggleFocus: _objectSpread({}, theme.typography.subtitle1)
});

const enhance = compose(connect(mapStateToProps, mapDispatchToProps), withStyles(styles), withTranslation(), withPlugins('SearchResults'));
export default enhance(SearchResults);