function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import _regeneratorRuntime from "@babel/runtime/regenerator";

var _marked = /*#__PURE__*/_regeneratorRuntime.mark(importState),
    _marked2 = /*#__PURE__*/_regeneratorRuntime.mark(importConfig),
    _marked3 = /*#__PURE__*/_regeneratorRuntime.mark(fetchCollectionManifests),
    _marked4 = /*#__PURE__*/_regeneratorRuntime.mark(appSaga);

import { all, call, put, takeEvery } from 'redux-saga/effects';
import { v4 as uuid } from 'uuid';
import { fetchManifests } from './iiif';
import { fetchWindowManifest } from './windows';
import { addWindow } from '../actions';
import ActionTypes from '../actions/action-types';
/** */

export function importState(action) {
  return _regeneratorRuntime.wrap(function importState$(_context) {
    while (1) switch (_context.prev = _context.next) {
      case 0:
        _context.next = 2;
        return all([...Object.entries(action.state.windows || {}).map(([_, window]) => call(fetchWindowManifest, {
          id: window.id,
          payload: window
        })), ...Object.entries(action.state.manifests || {}).filter(([_, manifest]) => !manifest.json).map(([_, manifest]) => call(fetchManifests, manifest.id))]);

      case 2:
      case "end":
        return _context.stop();
    }
  }, _marked);
}
/** Add windows from the imported config */

export function importConfig({
  config: {
    thumbnailNavigation,
    windows
  }
}) {
  var thunks;
  return _regeneratorRuntime.wrap(function importConfig$(_context2) {
    while (1) switch (_context2.prev = _context2.next) {
      case 0:
        if (!(!windows || windows.length === 0)) {
          _context2.next = 2;
          break;
        }

        return _context2.abrupt("return");

      case 2:
        _context2.next = 4;
        return all(windows.map(miradorWindow => {
          const windowId = `window-${uuid()}`;
          const manifestId = miradorWindow.manifestId || miradorWindow.loadedManifest;
          return call(addWindow, _objectSpread({
            // these are default values ...
            id: windowId,
            manifestId,
            thumbnailNavigationPosition: thumbnailNavigation && thumbnailNavigation.defaultPosition
          }, miradorWindow));
        }));

      case 4:
        thunks = _context2.sent;
        _context2.next = 7;
        return all(thunks.map(thunk => put(thunk)));

      case 7:
      case "end":
        return _context2.stop();
    }
  }, _marked2);
}
/** */

export function fetchCollectionManifests(action) {
  var collectionPath, manifestId;
  return _regeneratorRuntime.wrap(function fetchCollectionManifests$(_context3) {
    while (1) switch (_context3.prev = _context3.next) {
      case 0:
        collectionPath = action.collectionPath, manifestId = action.manifestId;
        _context3.next = 3;
        return call(fetchManifests, manifestId, ...collectionPath);

      case 3:
      case "end":
        return _context3.stop();
    }
  }, _marked3);
}
/** */

export default function appSaga() {
  return _regeneratorRuntime.wrap(function appSaga$(_context4) {
    while (1) switch (_context4.prev = _context4.next) {
      case 0:
        _context4.next = 2;
        return all([takeEvery(ActionTypes.IMPORT_MIRADOR_STATE, importState), takeEvery(ActionTypes.IMPORT_CONFIG, importConfig), takeEvery(ActionTypes.SHOW_COLLECTION_DIALOG, fetchCollectionManifests)]);

      case 2:
      case "end":
        return _context4.stop();
    }
  }, _marked4);
}