import _regeneratorRuntime from "@babel/runtime/regenerator";

var _marked = /*#__PURE__*/_regeneratorRuntime.mark(launchSaga);

import { all, call, spawn } from 'redux-saga/effects';
import appSaga from './app';
import iiifSaga from './iiif';
import windowSaga from './windows';
import annotationsSaga from './annotations';
import authSaga from './auth';
/** */

function launchSaga(saga) {
  return _regeneratorRuntime.wrap(function launchSaga$(_context) {
    while (1) switch (_context.prev = _context.next) {
      case 0:
        if (!true) {
          _context.next = 12;
          break;
        }

        _context.prev = 1;
        _context.next = 4;
        return call(saga);

      case 4:
        return _context.abrupt("break", 12);

      case 7:
        _context.prev = 7;
        _context.t0 = _context["catch"](1);
        console.log(_context.t0);

      case 10:
        _context.next = 0;
        break;

      case 12:
      case "end":
        return _context.stop();
    }
  }, _marked, null, [[1, 7]]);
}
/** */


function getRootSaga(pluginSagas = []) {
  return /*#__PURE__*/_regeneratorRuntime.mark(function rootSaga() {
    var sagas;
    return _regeneratorRuntime.wrap(function rootSaga$(_context2) {
      while (1) switch (_context2.prev = _context2.next) {
        case 0:
          sagas = [annotationsSaga, appSaga, iiifSaga, windowSaga, authSaga, ...pluginSagas];
          _context2.next = 3;
          return all(sagas.map(saga => spawn(launchSaga, saga)));

        case 3:
        case "end":
          return _context2.stop();
      }
    }, rootSaga);
  });
}

export default getRootSaga;